c*********************************************************************c
      subroutine  NMSSMDeltaRho(slhafile,ischeme)
      implicit none
      integer ierror,I2G3,I2G4,I6G3,I6G4,I5G3,I5G4,I3G3,ischeme,
     .        iHSM,i,imwcon,ierrhiggs
      character*30 slhafile
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3      
      double precision nms_full_Zself,nms_full_Wself,
     .     selfww2LQCD,selfzz2LQCD,selfZEW_la,selfWEW_la,
     .     selfZEW,selfWEW,MHSM,drsusy1L,drsusyas,drsusyew,
     .     DelAlfa,rk,aSMMH2
      double precision dRho1L,dRho_atas,dRho_ew,delrho2LEW
      double precision dRho1Lsm,dRho_atassm,dRho_ewsm,drho2LQCDSM
      double precision SMselfZ,SMselfW,delrho1LSSM,dMTSM,delrho2LEWSM
      double precision SMselfWDP,SMselfWSP,SMselfZDP,SMselfZSP
      double precision dMWoMW,dMZoMZ 
      common/vectorself/dMWoMW,dMZoMZ  
      double precision mtpole,mbMsmb,MSin,MCin
      common /topoles/ mtpole,mbMsmb,MSin,MCin  
      double precision RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0(3), absAd0(3), absAe0(3),  
     &                 ml20(3), mer20(3), mq20(3), mdr20(3), mur20(3),
     &                 phiAu0(3), phiAd0(3), phiAe0(3)
      common/slhaDRpara/RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0, absAd0, absAe0,  
     &                 ml20, mer20, mq20, mdr20, mur20,phiAu0,phiAd0,phiAe0
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)

      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3) 
      double precision ZH5(5,5),ZH(6,6)
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU          
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv        
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)     
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe     
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)     
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu 
      double precision Qs,Qinp,xQs
      common /scale/ Qs  
      common /SUSYscale/ Qinp 
      double precision MW2SM,MW21L,MW22LQCD,MW22LEW
      common /SMWmass/MW2SM
      common /WMASS_NMSSM/MW21L,MW22LQCD,MW22LEW  
      logical CPcon,MHpmInput,onelswitch,mQrun      
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch  
      common/MWCONiss/imwcon             
#include "defloop.h"
#include "HdecayTCLs.inc"     
      phiAu=phiAu0; mq2=mq20;mur2=mur20;absAu=absAu0   
      MT=mtpole           
      MB=mbMsmb 
      MS=MSin
      MC=MCin 

      alpha=alfa0 
c      MW= sqrt(MZ**2/2D0*(1+(1-4*pi*alpha/(sqrt(2D0)*Gf*MZ**2)))) 
c      MW=MW0

      MW=sqrt(MW22LEW)       
      call treelevelmasses_MW(MW,MZ,alpha,ischeme,ierrhiggs)
       if (ierrhiggs.eq.1)then
         print*, "Negative or NAN Higgs mass Eigenvalues in W-mass calculation"
         print*, "stop rho parameter calculation"
         return
       endif      
      call couplings  
      call couplingsXX   
       rk= abs(ZH5(1,4))
       ihsm=1
       do i=2,5
       if (abs(ZH5(i,4)).gt.rk)then
         ihsm=i
         rk =  abs(ZH5(i,4))
       endif
       enddo
       aSMMH2=MH(ihsm)**2        
c      Print*,"MT", MT 
c      Qs=Qinp
      Qs=MZ           
      dRho1L= (3*MFu2(3)+3*MFd2(3)+MFe2(3))/16D0/pi2/v**2 +
     & 3*MFD2(3)*MFu2(3)*Log(MFU2(3)/MFD2(3))/8D0/pi2/v**2/(MFd2(3)-MFu2(3))
      dRho1LSM=dRho1L

	  do I2G3= 1,2,1
	  dRho1L = dRho1L - 1/Pi2*(1/(16.D0*MW2)*
     &        (myA0(MassHpm2(I2G3))*CHmHpWW(I2G3,I2G3)) + 
     &       1/MZ2*(1/4.D0*(CHpHmZ**2*
     &       myB0i(bb00,0.D0,MassHpm2(I2G3),MassHpm2(I2G3)))-
     &       1/16.D0*(myA0(MassHpm2(I2G3))*CHpHmZZ(I2G3,I2G3))))
	   enddo
	  do I6G3= 1,6,1
      dRho1L = dRho1L + Ic/Pi2*(myA0(Masshh2(I6G3))*
     &       (1/(32.D0*MW2)*ChhWmWp(I6G3,I6G3) - 
     &         1/(32.D0*MZ2)*ChhZZ(I6G3,I6G3)))
	   enddo
	  do I2G3= 1,2,1
	  do I6G3= 1,6,1
	  dRho1L = dRho1L - 1/(4.D0*MW2*Pi2)*
     &     (myB0i(bb00,0.D0,Masshh2(I6G3),MassHpm2(I2G3))*
     &     ChHmWp(I2G3,I6G3)*ChHpWm(I6G3,I2G3))
	   enddo
	   enddo
	  do I6G3= 1,6,1
	  do I6G4= 1,6,1
	   dRho1L = dRho1L - 1/(8.D0*MZ2*Pi2)*
     &     (myB0i(bb00,0.D0,Masshh2(I6G3),Masshh2(I6G4))*
     &     ChhZ(I6G3,I6G4)**2)
	   enddo
	   enddo
	  do I2G3= 1,2,1
	  do I2G4= 1,2,1

	  dRho1L = dRho1L - 
     &    1/(MZ2*Pi2)*((CF12ZL(I2G3,I2G4)*CF12ZL(I2G4,I2G3) + 
     &    CF12ZR(I2G3,I2G4)*CF12ZR(I2G4,I2G3))*
     &    (1/8.D0*myA0(MCha2(I2G4)) - 
     &    1/4.D0*myB0i(bb00,0.D0,MCha2(I2G3),MCha2(I2G4))) - 
     &    1/8.D0*(myB0i(bb0,0.D0,MCha2(I2G3),MCha2(I2G4))*
     &    (CF12ZL(I2G4,I2G3)*(CF12ZR(I2G3,I2G4)*
     &    MCha(I2G3)*MCha(I2G4) - CF12ZL(I2G3,I2G4)*MCha2(I2G3)) + 
     &    CF12ZR(I2G4,I2G3)*(CF12ZL(I2G3,I2G4)*MCha(I2G3)*MCha(I2G4) - 
     &    CF12ZR(I2G3,I2G4)*MCha2(I2G3)))))
	   enddo
	   enddo
	  do I2G3= 1,2,1
	  do I5G3= 1,5,1

	  dRho1L = dRho1L + 1/(MW2*Pi2)*((CLF12F11W(I2G3,I5G3)*
     &    DCONJG(CLF12F11W(I2G3,I5G3)) + 
     &    DCONJG(CRF12F11W(I2G3,I5G3))*CRF12F11W(I2G3,I5G3))*
     &    (1/8.D0*myA0(MCha2(I2G3)) - 
     &    1/4.D0*myB0i(bb00,0.D0,MCha2(I2G3),MNeu2(I5G3))) - 
     &    1/8.D0*(myB0i(bb0,0.D0,MCha2(I2G3),MNeu2(I5G3))*
     &    (CLF12F11W(I2G3,I5G3)*(DCONJG(CRF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &    MNeu(I5G3) - DCONJG(CLF12F11W(I2G3,I5G3))*MNeu2(I5G3))+
     &    CRF12F11W(I2G3,I5G3)*(DCONJG(CLF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &    MNeu(I5G3) - DCONJG(CRF12F11W(I2G3,I5G3))*MNeu2(I5G3)))))
	   enddo
	   enddo
	  do I5G3= 1,5,1
	  do I5G4= 1,5,1
	  dRho1L = dRho1L - 1/(MZ2*Pi2)*((CF11ZL(I5G3,I5G4)*CF11ZL(I5G4,I5G3) + 
     &        CF11ZR(I5G3,I5G4)*CF11ZR(I5G4,I5G3))*(1/16.D0*myA0(MNeu2(I5G4)) - 
     &        1/8.D0*myB0i(bb00,0.D0,MNeu2(I5G3),MNeu2(I5G4))) - 
     &        1/16.D0*(myB0i(bb0,0.D0,MNeu2(I5G3),MNeu2(I5G4))*
     &        (CF11ZL(I5G4,I5G3)*(CF11ZR(I5G3,I5G4)*MNeu(I5G3)*MNeu(I5G4) - 
     &        CF11ZL(I5G3,I5G4)*MNeu2(I5G3)) + CF11ZR(I5G4,I5G3)*
     &        (CF11ZL(I5G3,I5G4)*MNeu(I5G3)*MNeu(I5G4) - 
     &        CF11ZR(I5G3,I5G4)*MNeu2(I5G3)))))
	   enddo
	   enddo  
	  do I3G3= 1,3,1
	  dRho1L = dRho1L - 
     &    1/Pi2*(1/(32.D0*MW2)*(g2**2*myA0(MSv2(I3G3))) - 
     &    1/MZ2*(1/16.D0*(CSvSvZZ*myA0(MSv2(I3G3))) - 
     &    1/4.D0*(CsvsvZ**2*myB0i(bb00,0.D0,MSv2(I3G3),MSv2(I3G3)))))
	   enddo
	  do I6G3= 1,6,1
	  dRho1L = dRho1L - 1/Pi2*(1/MW2*(1/16.D0*
     &         (myA0(MSe2(I6G3))*CSeSeWW(I6G3,I6G3)) + 
     &         3/16.D0*(myA0(MSd2(I6G3))*CSdSdWW(I6G3,I6G3) + 
     &         myA0(MSu2(I6G3))*CSuSuWW(I6G3,I6G3))) - 
     &         1/MZ2*(1/16.D0*(myA0(MSe2(I6G3))*CSeSeZZ(I6G3,I6G3)) + 
     &         3/16.D0*(myA0(MSd2(I6G3))*CSdSdZZ(I6G3,I6G3) + 
     &         myA0(MSu2(I6G3))*CSuSuZZ(I6G3,I6G3))))
	   enddo
	  do I3G3= 1,3,1
	  do I6G3= 1,6,1
	  dRho1L = dRho1L + 1/(4.D0*MW2*Pi2)*
     &     (myB0i(bb00,0.D0,MSe2(I6G3),MSv2(I3G3))*
     &       DCONJG(CsesvW(I6G3,I3G3))*CsesvW(I6G3,I3G3))
	   enddo
	   enddo
	  do I6G3= 1,6,1
	  do I6G4= 1,6,1
	  dRho1L = dRho1L + 1/Pi2*(3/(4.D0*MW2)*
     &    (myB0i(bb00,0.D0,MSd2(I6G4),MSu2(I6G3))*
     &    DCONJG(CsdsuW(I6G4,I6G3))*CsdsuW(I6G4,I6G3)) - 
     &    1/MZ2*(1/4.D0*(myB0i(bb00,0.D0,MSe2(I6G3),MSe2(I6G4))*
     &    CsemsepZ(I6G3,I6G4)*CsemsepZ(I6G4,I6G3)) + 
     &    3/4.D0*(myB0i(bb00,0.D0,MSd2(I6G3),MSd2(I6G4))*
     &    CsdmsdpZ(I6G3,I6G4)*CsdmsdpZ(I6G4,I6G3) + 
     &    myB0i(bb00,0.D0,MSu2(I6G3),MSu2(I6G4))*
     &    CsupsumZ(I6G3,I6G4)*CsupsumZ(I6G4,I6G3))))
	   enddo
	   enddo
	   xQs=Qs	        
      call ini_QCD(xQs,ischeme,ierror,0)
      call SelfTWW_QCD(selfww2LQCD)            
      call SelfTZZ_QCD(selfzz2LQCD)      
      dRho_atas=dRho1L+(selfzz2LQCD-selfww2LQCD)
c      print*, "NMSSM",dRho1L,(selfzz2LQCD-selfww2LQCD)
      call SelfTVV_QCDSM(drho2LQCDSM,ischeme)
      dRho_atasSM=dRho1LSM+drho2LQCDSM
c      print*, "drho2LQCDSM",dRho1LSM,drho2LQCDSM
      call ini_atlambda(xQs,MHSM,MW,ischeme,ierror,0)

      if(ierror .gt.0)then
         MHSM= sqrt(aSMMH2)
      endif             
      call ini_SM(MHSM,MT,MW,MZ,alpha,Qs**2,delrho1LSSM,dMTSM,ischeme)
      call SelfTWW2L_SMEW(SMselfWDP,SMselfWSP,SMselfW)
      call SelfTZZ2L_SMEW(SMselfZDP,SMselfZSP,SMselfZ)
      delrho2LEWSM=SMselfZ-SMselfW +delrho1LSSM 
      dRho_ewsm=dRho_atassm+ delrho2LEWSM      

      if(ierror.eq.0 .and. abs(MW22LQCD-MW22LEW) .gt.1D-10 )then
      call SelfTWW2L_MT4(selfWEW,0)
      call SelfTZZ2L_MT4(selfZEW,0) 
      call SelfTWW2L_lambda(selfWEW_la)
      call SelfTZZ2L_lambda(selfZEW_la)  
           selfZEW=selfZEW+selfZEW_la
           selfWEW=selfWEW+selfWEW_la           
           delrho2LEW=(-selfWEW+selfZEW)-dMZoMZ*dMZoMZ+
     &        dMWoMW*dMZoMZ             
      dRho_ew=dRho_atas+ delrho2LEW
      else
      dRho_ewsm=dRho_atassm 
      dRho_ew=dRho_atas
      endif  
      open(unit=46,file=slhafile,status="old",position="append",action='write')
      if (ischeme.eq.1)then
      write(46,51) 'BLOCK DeltaRhoDR'
      elseif(ischeme.eq.3)then
      write(46,51) 'BLOCK DeltaRhoOS'
      endif
      write(46,53) 1,1,dRho1LSM,dRho1L,'DeltaRho in the SM and NMSSM at 1-loop'
      write(46,53) 1,2,dRho_atasSM,dRho_atas,'DeltaRho in the SM and NMSSM at 2-loop QCD'
      write(46,53) 1,3,dRho_ewsm,dRho_ew,'DeltaRho in the SM and NMSSM at 2-loop EW'   
#ifdef testdeltar
      DelAlfa=DelAlfa0      
      call delr_1L_nmssm(alpha,drsusy1L)
      print*, "drsusy1L",drsusy1L
      call NMSSMDeltaR1L_OS(Qs**2,MW,MZ,GF,MT,alphaS,alpha,
     &          DelAlfa,drsusy1L,1,ischeme,ierror,0)    
      dRSUSYas =drsusy1L- CW2/SW2*((selfzz2LQCD-selfww2LQCD)-drho2LQCDSM)
      print*, drsusy1L, - CW2/SW2*(dRho1L-dRho1LSM),- CW2/SW2*((selfzz2LQCD-selfww2LQCD)-drho2LQCDSM)
      print*, "(selfzz2LQCD-selfww2LQCD)",(selfzz2LQCD-selfww2LQCD),drho2LQCDSM
      if(ierror.eq.0 .and. abs(MW22LQCD-MW22LEW) .gt.1D-10 )then
      dRSUSYew=dRSUSYas- CW2/SW2*(delrho2LEW-delrho2LEWSM)
      else
      dRSUSYew=dRSUSYas
      endif
      write(46,51) 'BLOCK DeltaRSUSY'
      write(46,52) 1,1,dRSUSY1L,'DeltaR in the  NMSSM at 1-loop'
      write(46,52) 1,2,dRSUSYas,'DeltaR in the NMSSM at 2-loop QCD'
      write(46,52) 1,3,dRSUSYew,'DeltaR in the NMSSM at 2-loop EW'                         
#endif
      close(46)
 51   format(A)
 52   format(1x,I2,1x,I2,3x,1P,E16.8,0P,3x,'#',1x,A) 
 53   format(1x,I2,1x,I2,3x,1P,E16.8,3x,E16.8,0P,3x,'#',1x,A)            
      end
