#define aNMSSM
#define aSM
c#define DEBUG 5
c==========================================================c       
       subroutine delr_1L_nmssm(alfa,delR)
       implicit none

#include "HdecayTCLs.inc" 
       integer I2G3, I2G4, I3G3, I3G4, I5G3, I5G4, I6G3, I6G4
       integer I2G5, I3G5, I5G5, I6G5, I2G6, I6G6,ihsm,i
       integer bb0,bb1,bb00,dbb0,dbb1,dbb00
       common /funcID/ bb0,bb1,bb00,dbb0,dbb1,dbb00      	
       double complex dup1, dup2, dup3, dup4
       double precision alfa,Q2,EL,rk,delR,addrun
       double precision aant1,aant2,aant3,aant4,aant5
       double precision abnt1,abnt2,abnt3,abnt4,abnt5,abnt6,abnt7,
     &  abnt8,abnt9,abnt10,abnt11,abnt12,abnt13,abnt14,abnt15,abnt16,
     &  abnt17,abnt18,abnt19,abnt20,abnt21,abnt22,abnt23,abnt24	
       double precision Qs
       common /scale/ Qs
       double precision B0T,myC0,myC00,myD0,myD00,myA0,ReB0i,Divergence
       double complex  dMW0, dMWsq1, dMZsq1, dSW1, dZAA1, dZe1
       double complex dZW1, dZZA1,myB0i
       double complex dvex1, dZfnm1,dZfne1,dZfmu1,dZfe1,dbox11
       double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3   
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       double precision ZH5(5,5),ZH(6,6)
       double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
       common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU      
       rk= abs(ZH5(1,4))
       ihsm=1
       do i=2,5
       if (abs(ZH5(i,4)).gt.rk)then
         ihsm=i
         rk =  abs(ZH5(i,4))
       endif
       enddo
       aMH2=MH(ihsm)**2      	
       Divergence=0D0
       EL = Sqrt(4*pi*alfa)
       MCha(:)= Sqrt(Mcha2(:))
       dup2 = 2*CWWZ**2 - 3*g2**2 + 8*Alfa*Pi
       Q2=Qs**2

#ifdef aSM
	dMW0 = 1/Pi**2*
     &     (-(1/16.D0*(dup2*(myA0(MW2)))) + 
     &       CWWZ**2*(3/16.D0*(myA0(MZ2)) - 
     &          MZ2/8.D0*(ReB0i(bb0,0.D0,MW2,MZ2)) - 
     &          1/2.D0*(ReB0i(bb00,0.D0,MW2,MZ2)))) - 
     &    (2*Alfa)/Pi*(ReB0i(bb00,0.D0,0.D0,MW2))
 
	Do I2G3= 1,1,1
	dMW0 = dMW0 + 1/(16.D0*Pi**2)*
     &     (CHmHpWW(I2G3,I2G3)*(myA0(MassHpm2(I2G3))) + 
     &       CHmWpA(I2G3)**2*(ReB0i(bb0,0.D0,0.D0,MassHpm2(I2G3))) + 
     &       CHmWpZ(I2G3)**2*(ReB0i(bb0,0.D0,MZ2,MassHpm2(I2G3))))

	ENDDo	
	dMW0 = dMW0+ Alfa/Pi*
     &    (1/SW2*(1/16.D0*(-(- (myA0(aMH2)) ) )+ 
     &         1/4.D0*(MW2*(ReB0i(bb0,0.D0,aMH2,MW2))- 
     &            (ReB0i(bb00,0.D0,aMH2,MW2)) )) )		


	Do I6G3= 1,1,1

	dMW0 = dMW0 - 1/Pi**2*
     &     (IC/32.D0*(ChhWmWp(I6G3,I6G3)*(myA0(Masshh2(I6G3))))  + 
     &       1/16.D0*(ChWmWp(I6G3)**2*
     &          (ReB0i(bb0,0.D0,MW2,Masshh2(I6G3)))))

	ENDDo 
	Do I2G3=  1,1,1
	Do I6G3= 1,1,1

	dMW0 = dMW0 + 1/(4.D0*Pi**2)*
     &     (ChHmWp(I2G3,I6G3)*ChHpWm(I6G3,I2G3)*
     &       (ReB0i(bb00,0.D0,Masshh2(I6G3),MassHpm2(I2G3))))

	ENDDo 
	ENDDo 		     
    
	Do I3G3= 1,3,1
	Do I3G4= 1,3,1

	dMW0 = dMW0 - 1/Pi**2*
     &     (CbtWm(I3G3,I3G4)*CtbWp(I3G3,I3G4)*
     &       (3/8.D0*((myA0(MassFd2(I3G4))) + 
     &            MassFu2(I3G3)*
     &             (ReB0i(bb0,0.D0,MassFd2(I3G4),MassFu2(I3G3))))
     &           - 3/4.D0*(ReB0i(bb00,0.D0,MassFd2(I3G4),
     &            MassFu2(I3G3)))))

	ENDDo
	ENDDo   
	
	Do I3G3= 1,3,1

	dMW0 = dMW0 - 1/Pi**2*
     &     (g2**2*(1/16.D0*(myA0(MassFe2(I3G3)))  - 
     &         1/8.D0*(ReB0i(bb00,0.D0,0.D0,MassFe2(I3G3)))))

	ENDDo 
 
#endif

#ifdef aNMSSM
	Do I2G3= 2,2,1
	dMW0 = dMW0 + 1/(16.D0*Pi**2)*
     &     (CHmHpWW(I2G3,I2G3)*(myA0(MassHpm2(I2G3))) + 
     &       CHmWpA(I2G3)**2*(ReB0i(bb0,0.D0,0.D0,MassHpm2(I2G3))) + 
     &       CHmWpZ(I2G3)**2*(ReB0i(bb0,0.D0,MZ2,MassHpm2(I2G3))))

	ENDDo	


	Do I3G3= 1,3,1

	dMW0 = dMW0 - 1/Pi**2*
     &     (g2**2*( - 
     &         1/32.D0*(myA0(MSv2(I3G3))) ))

	ENDDo 

	Do I6G3= 2,6,1

	dMW0 = dMW0 - 1/Pi**2*
     &     (IC/32.D0*(ChhWmWp(I6G3,I6G3)*(myA0(Masshh2(I6G3))))  + 
     &       1/16.D0*(ChWmWp(I6G3)**2*
     &          (ReB0i(bb0,0.D0,MW2,Masshh2(I6G3)))))

	ENDDo 

	Do I6G3= 1,6,1

	dMW0 = dMW0 - 1/Pi**2*
     &     ( - 
     &       1/16.D0*(CSeSeWW(I6G3,I6G3)*(myA0(MSe2(I6G3)))) - 
     &       3/16.D0*(CSdSdWW(I6G3,I6G3)*(myA0(MSd2(I6G3))) + 
     &          CSuSuWW(I6G3,I6G3)*(myA0(MSu2(I6G3)))) )

	ENDDo 
	

	Do I2G3= 1,2,1
	Do I5G3= 1,5,1

	dMW0 = dMW0 + 1/Pi**2*
     &     (1/8.D0*((CLF12F11W(I2G3,I5G3)*
     &             (DCONJG(CRF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &                MNeu(I5G3) - 
     &               DCONJG(CLF12F11W(I2G3,I5G3))*MNeu2(I5G3))+
     &              CRF12F11W(I2G3,I5G3)*
     &             (DCONJG(CLF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &                MNeu(I5G3) - 
     &               DCONJG(CRF12F11W(I2G3,I5G3))*MNeu2(I5G3)))*
     &          (ReB0i(bb0,0.D0,MCha2(I2G3),MNeu2(I5G3)))) - 
     &       (CLF12F11W(I2G3,I5G3)*
     &           DCONJG(CLF12F11W(I2G3,I5G3)) + 
     &          DCONJG(CRF12F11W(I2G3,I5G3))*
     &           CRF12F11W(I2G3,I5G3))*
     &        (1/8.D0*(myA0(MCha2(I2G3))) - 
     &          1/4.D0*(ReB0i(bb00,0.D0,MCha2(I2G3),MNeu2(I5G3)))))

	ENDDo
	ENDDo

	Do I2G3=  1,2,1
	Do I6G3= 1,6,1

	dMW0 = dMW0 + 1/(4.D0*Pi**2)*
     &     (ChHmWp(I2G3,I6G3)*ChHpWm(I6G3,I2G3)*
     &       (ReB0i(bb00,0.D0,Masshh2(I6G3),MassHpm2(I2G3))))

	ENDDo 
	ENDDo 
	
	Do I2G3=  1,1,1
	Do I6G3= 1,1,1

	dMW0 = dMW0 - 1/(4.D0*Pi**2)*
     &     (ChHmWp(I2G3,I6G3)*ChHpWm(I6G3,I2G3)*
     &       (ReB0i(bb00,0.D0,Masshh2(I6G3),MassHpm2(I2G3))))

	ENDDo 
	ENDDo 	

	dMW0 = dMW0- Alfa/Pi*
     &    (1/SW2*(1/16.D0*(-(- (myA0(aMH2)) ) )+ 
     &         1/4.D0*(MW2*(ReB0i(bb0,0.D0,aMH2,MW2))- 
     &            (ReB0i(bb00,0.D0,aMH2,MW2)) )) )

	Do I3G3=1,3,1
	Do I6G3=1,6,1

	dMW0 = dMW0 - 1/(4.D0*Pi**2)*
     &     (DCONJG(CsesvW(I6G3,I3G3))*CsesvW(I6G3,I3G3)*
     &       (ReB0i(bb00,0.D0,MSe2(I6G3),MSv2(I3G3))))

	ENDDo
	ENDDo

	Do I6G3= 1,6,1
	Do I6G4= 1,6,1

	dMW0 = dMW0 - 3/(4.D0*Pi**2)*
     &     (DCONJG(CsdsuW(I6G4,I6G3))*CsdsuW(I6G4,I6G3)*
     &       (ReB0i(bb00,0.D0,MSd2(I6G4),MSu2(I6G3))))

	ENDDo 
	ENDDo 
#endif
#if DEBUG >= 4
	print*, "dMW0", dMW0
#endif
#ifdef aSM
	dMWsq1 = 1/Pi**2*
     &     (-(1/16.D0*(dup2*(myA0(MW2)))) + 
     &       CWWZ**2*(-(MW2*
     &             (3/16.D0*(ReB0i(bb0,MW2,MW2,MZ2)) - 
     &               1/8.D0*(ReB0i(bb1,MW2,MW2,MZ2)))) + 
     &          3/16.D0*(myA0(MZ2)) - 
     &          MZ2/8.D0*(ReB0i(bb0,MW2,MW2,MZ2)) - 
     &          1/2.D0*(ReB0i(bb00,MW2,MW2,MZ2)))) + 
     &    Alfa/Pi*(-(MW2*(5/4.D0*(ReB0i(bb0,MW2,0.D0,MW2)) + 
     &            1/2.D0*(ReB0i(bb1,MW2,0.D0,MW2)))) - 
     &       2*(ReB0i(bb00,MW2,0.D0,MW2)))
	Do I3G3= 1,3,1
	Do I3G4= 1,3,1

	dMWsq1 = dMWsq1 - 
     &    1/Pi**2*(CbtWm(I3G3,I3G4)*CtbWp(I3G3,I3G4)*
     &       (3/8.D0*(myA0(MassFd2(I3G4))) - 
     &         3/8.D0*(MW2*(ReB0i(bb1,MW2,MassFd2(I3G4),
     &               MassFu2(I3G3))) + 
     &            (MW2 - MassFu2(I3G3))*
     &             (ReB0i(bb0,MW2,MassFd2(I3G4),MassFu2(I3G3)))
     &            ) - 3/4.D0*
     &          (ReB0i(bb00,MW2,MassFd2(I3G4),MassFu2(I3G3)))))

	ENDDo
	ENDDo
	Do I3G3= 1,3,1

	dMWsq1 = dMWsq1 - 
     &    1/Pi**2*(g2**2*(1/16.D0*
     &          (MW2*(ReB0i(bb1,MW2,0.D0,MassFe2(I3G3))) + 
     &            (myA0(MassFe2(I3G3)))) - 
     &         1/8.D0*(ReB0i(bb00,MW2,0.D0,MassFe2(I3G3)))))

	ENDDo	
	Do I2G3= 1,1,1

	dMWsq1 = dMWsq1 + 
     &    1/(16.D0*Pi**2)*(CHmHpWW(I2G3,I2G3)*
     &        (myA0(MassHpm2(I2G3))) + 
     &       CHmWpA(I2G3)**2*
     &        (ReB0i(bb0,MW2,0.D0,MassHpm2(I2G3))) + 
     &       CHmWpZ(I2G3)**2*(ReB0i(bb0,MW2,MZ2,MassHpm2(I2G3))))

	ENDDo	

	Do I6G3= 1,1,1

	dMWsq1 = dMWsq1 - 1/Pi**2*
     &     (IC/32.D0*(ChhWmWp(I6G3,I6G3)*(myA0(Masshh2(I6G3))))  + 
     &       1/16.D0*(ChWmWp(I6G3)**2*
     &          (ReB0i(bb0,MW2,MW2,Masshh2(I6G3)))))

	ENDDo  
	
	Do I2G3= 1,1,1
	Do I6G3= 1,1,1

	dMWsq1 = dMWsq1 + 
     &    1/(4.D0*Pi**2)*(ChHmWp(I2G3,I6G3)*ChHpWm(I6G3,I2G3)*
     &       (ReB0i(bb00,MW2,Masshh2(I6G3),MassHpm2(I2G3))))

	ENDDo
	ENDDo	    	
#endif
#ifdef aNMSSM
	Do I2G3= 2,2,1
	dMWsq1 = dMWsq1 + 
     &    1/(16.D0*Pi**2)*(CHmHpWW(I2G3,I2G3)*
     &        (myA0(MassHpm2(I2G3))) + 
     &       CHmWpA(I2G3)**2*
     &        (ReB0i(bb0,MW2,0.D0,MassHpm2(I2G3))) + 
     &       CHmWpZ(I2G3)**2*(ReB0i(bb0,MW2,MZ2,MassHpm2(I2G3))))
	ENDDo

	Do I3G3= 1,3,1

	dMWsq1 = dMWsq1 - 
     &    1/Pi**2*(g2**2*( - 
     &         1/32.D0*(myA0(MSv2(I3G3))) ))

	ENDDo	

	Do I6G3= 2,6,1

	dMWsq1 = dMWsq1 - 
     &    1/Pi**2*(IC/32.D0*(ChhWmWp(I6G3,I6G3)*
     &          (myA0(Masshh2(I6G3)))) + 
     &       1/16.D0*(ChWmWp(I6G3)**2*
     &          (ReB0i(bb0,MW2,MW2,Masshh2(I6G3)))))

	ENDDo
	Do I6G3= 1,6,1

	dMWsq1 = dMWsq1 - 
     &    1/Pi**2*( - 
     &       1/16.D0*(CSeSeWW(I6G3,I6G3)*(myA0(MSe2(I6G3)))) - 
     &       3/16.D0*(CSdSdWW(I6G3,I6G3)*(myA0(MSd2(I6G3))) + 
     &          CSuSuWW(I6G3,I6G3)*(myA0(MSu2(I6G3)))))

	ENDDo	

	Do I2G3= 1,2,1
	Do I5G3= 1,5,1

	dMWsq1 = dMWsq1 + 
     &    1/Pi**2*(1/8.D0*((CLF12F11W(I2G3,I5G3)*
     &             (DCONJG(CRF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &                MNeu(I5G3) + 
     &               DCONJG(CLF12F11W(I2G3,I5G3))*
     &                (MW2 - MNeu2(I5G3))) + 
     &            CRF12F11W(I2G3,I5G3)*
     &             (DCONJG(CLF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &                MNeu(I5G3) + 
     &               DCONJG(CRF12F11W(I2G3,I5G3))*
     &                (MW2 - MNeu2(I5G3))))*
     &          (ReB0i(bb0,MW2,MCha2(I2G3),MNeu2(I5G3)))) - 
     &       (CLF12F11W(I2G3,I5G3)*
     &           DCONJG(CLF12F11W(I2G3,I5G3)) + 
     &          DCONJG(CRF12F11W(I2G3,I5G3))*
     &           CRF12F11W(I2G3,I5G3))*
     &        (1/8.D0*(myA0(MCha2(I2G3))) - 
     &          1/4.D0*(ReB0i(bb00,MW2,MCha2(I2G3),MNeu2(I5G3))) - 
     &          MW2/8.D0*(ReB0i(bb1,MW2,MCha2(I2G3),MNeu2(I5G3)))))

	ENDDo
	ENDDo

	Do I2G3= 1,2,1
	Do I6G3= 1,6,1
	if ((I2G3+I6G3).gt.2)then
	dMWsq1 = dMWsq1 + 
     &    1/(4.D0*Pi**2)*(ChHmWp(I2G3,I6G3)*ChHpWm(I6G3,I2G3)*
     &       (ReB0i(bb00,MW2,Masshh2(I6G3),MassHpm2(I2G3))))
	endif
	ENDDo
	ENDDo


	Do I3G3= 1,3,1
	Do I6G3= 1,6,1

	dMWsq1 = dMWsq1 - 
     &    1/(4.D0*Pi**2)*(DCONJG(CsesvW(I6G3,I3G3))*
     &       CsesvW(I6G3,I3G3)*
     &       (ReB0i(bb00,MW2,MSe2(I6G3),MSv2(I3G3))))

	ENDDo
	ENDDo

	Do I6G3= 1,6,1
	Do I6G4= 1,6,1

	dMWsq1 = dMWsq1 - 
     &    3/(4.D0*Pi**2)*(DCONJG(CsdsuW(I6G4,I6G3))*
     &       CsdsuW(I6G4,I6G3)*
     &       (ReB0i(bb00,MW2,MSd2(I6G4),MSu2(I6G3))))

	ENDDo
	ENDDo
	
	dMWsq1 = dMWsq1 - Alfa/Pi*
     &    (1/SW2*(1/16.D0*(-(- (myA0(aMH2)) ) )+ 
     &         1/4.D0*(MW2*(ReB0i(bb0,MW2,aMH2,MW2))- 
     &            (ReB0i(bb00,MW2,aMH2,MW2)) )) )	
#endif
#if DEBUG >= 4
	print*, "dMWsq1", dMWsq1
#endif

	dup4 = SW2*g1**2 + CW2*g2**2 + 2*CW*(g1*g2*SW)

#ifdef aSM
	dMZsq1 = 1/Pi**2*
     &    (dup4*(3/16.D0*(ReB0i(bb00,MZ2,0.D0,0.D0)) - 
     &         (3*MZ2)/32.D0*(ReB0i(bb1,MZ2,0.D0,0.D0))) + 
     &      CWWZ**2*(1/4.D0*(myA0(MW2)) + 
     &         (-MW2/8.D0 - (5*MZ2)/16.D0)*(ReB0i(bb0,MZ2,MW2,MW2)) - 
     &         1/2.D0*(ReB0i(bb00,MZ2,MW2,MW2)) - 
     &         MZ2/8.D0*(ReB0i(bb1,MZ2,MW2,MW2))))

	Do I2G3= 1,1,1

	dMZsq1 = dMZsq1 + 
     &    1/Pi**2*(1/16.D0*(CHpHmZZ(I2G3,I2G3)*
     &          (myA0(MassHpm2(I2G3)))) + 
     &       1/8.D0*(CHmWpZ(I2G3)**2*
     &          (ReB0i(bb0,MZ2,MW2,MassHpm2(I2G3)))) - 
     &       1/4.D0*(CHpHmZ**2*
     &          (ReB0i(bb00,MZ2,MassHpm2(I2G3),MassHpm2(I2G3)))
     &          ))

	ENDDo


	Do I3G3= 1,3,1

	dMZsq1 = dMZsq1 + 
     &    1/Pi**2*(-(MZ2*(1/8.D0*
     &             ((ctautauZL**2 + ctautauZR**2)*
     &               (ReB0i(bb1,MZ2,MassFe2(I3G3),
     &                 MassFe2(I3G3)))) + 
     &            3/8.D0*((CddZL**2 + CddZR**2)*
     &                (ReB0i(bb1,MZ2,MassFd2(I3G3),
     &                  MassFd2(I3G3))) + 
     &               (CuuZL**2 + CuuZR**2)*
     &                (ReB0i(bb1,MZ2,MassFu2(I3G3),
     &                  MassFu2(I3G3))))))  - 
     &       1/8.D0*((ctautauZL - ctautauZR)**2*MassFe2(I3G3)*
     &          (ReB0i(bb0,MZ2,MassFe2(I3G3),MassFe2(I3G3))))-
     &         3/8.D0*((CddZL**2 + CddZR**2)*
     &           (myA0(MassFd2(I3G3))) + 
     &          (CuuZL**2 + CuuZR**2)*(myA0(MassFu2(I3G3))) + 
     &          (CddZL - CddZR)**2*MassFd2(I3G3)*
     &           (ReB0i(bb0,MZ2,MassFd2(I3G3),MassFd2(I3G3)))+
     &            (CuuZL - CuuZR)**2*MassFu2(I3G3)*
     &           (ReB0i(bb0,MZ2,MassFu2(I3G3),MassFu2(I3G3))))-
     &         (ctautauZL**2 + ctautauZR**2)*
     &        (1/8.D0*(myA0(MassFe2(I3G3))) - 
     &          1/4.D0*(ReB0i(bb00,MZ2,MassFe2(I3G3),
     &             MassFe2(I3G3)))) + 
     &       3/4.D0*((CddZL**2 + CddZR**2)*
     &           (ReB0i(bb00,MZ2,MassFd2(I3G3),MassFd2(I3G3)))+
     &            (CuuZL**2 + CuuZR**2)*
     &           (ReB0i(bb00,MZ2,MassFu2(I3G3),MassFu2(I3G3))))
     &        )

	ENDDo	
	dMZsq1 = dMZsq1 -(Alfa/(Pi*SW2)*
     &      (1/CW2*( + 
     &           1/16.D0*( - (myA0(aMH2)) )+ 
     &           1/4.D0*( + 
     &              (ReB0i(bb00,MZ2,aMH2,MZ2))) )  - 
     &        MW2/(4.D0*CW2**2)*(ReB0i(bb0,MZ2,aMH2,MZ2))))	

	Do I6G3= 1,1,1

	dMZsq1 = dMZsq1 - 
     &    1/Pi**2*(IC/32.D0*(ChhZZ(I6G3,I6G3)*
     &          (myA0(Masshh2(I6G3))))   + 
     &       1/16.D0*(ChZZ(I6G3)**2*
     &          (ReB0i(bb0,MZ2,MZ2,Masshh2(I6G3)))))

	ENDDo	
	
	Do I6G3= 1,1,1
	Do I6G4= 1,1,1

	dMZsq1 = dMZsq1 - 
     &    1/Pi**2*(1/8.D0*(ChhZ(I6G3,I6G4)**2*
     &          (ReB0i(bb00,MZ2,Masshh2(I6G3),Masshh(I6G4)**2))))

	ENDDo
	ENDDo		
#endif
#ifdef aNMSSM
	Do I2G3= 2,2,1

	dMZsq1 = dMZsq1 + 
     &    1/Pi**2*(1/16.D0*(CHpHmZZ(I2G3,I2G3)*
     &          (myA0(MassHpm2(I2G3)))) + 
     &       1/8.D0*(CHmWpZ(I2G3)**2*
     &          (ReB0i(bb0,MZ2,MW2,MassHpm2(I2G3)))) - 
     &       1/4.D0*(CHpHmZ**2*
     &          (ReB0i(bb00,MZ2,MassHpm2(I2G3),MassHpm2(I2G3)))
     &          ))

	ENDDo

	Do I3G3= 1,3,1

	dMZsq1 = dMZsq1 + 
     &    1/Pi**2*(+ 
     &       1/16.D0*(CSvSvZZ*(myA0(MSv2(I3G3)))) 
     &         - 1/4.D0*(CsvsvZ**2*
     &          (ReB0i(bb00,MZ2,MSv2(I3G3),MSv2(I3G3)))))

	ENDDo

	Do I6G3= 1,6,1

	dMZsq1 = dMZsq1 - 
     &    1/Pi**2*( - 
     &       1/16.D0*(CSeSeZZ(I6G3,I6G3)*(myA0(MSe2(I6G3)))) - 
     &       3/16.D0*(CSdSdZZ(I6G3,I6G3)*(myA0(MSd2(I6G3))) + 
     &          CSuSuZZ(I6G3,I6G3)*(myA0(MSu2(I6G3)))) )

	ENDDo
	
	Do I6G3= 2,6,1

	dMZsq1 = dMZsq1 - 
     &    1/Pi**2*(IC/32.D0*(ChhZZ(I6G3,I6G3)*
     &          (myA0(Masshh2(I6G3))))   + 
     &       1/16.D0*(ChZZ(I6G3)**2*
     &          (ReB0i(bb0,MZ2,MZ2,Masshh2(I6G3)))))

	ENDDo	

	Do I2G3= 1,2,1
	Do I2G4= 1,2,1

	dMZsq1 = dMZsq1 + 
     &    1/Pi**2*(1/8.D0*((CF12ZL(I2G4,I2G3)*
     &             (CF12ZR(I2G3,I2G4)*MCha(I2G3)*MCha(I2G4) - 
     &               CF12ZL(I2G3,I2G4)*MCha2(I2G3)) + 
     &            CF12ZR(I2G4,I2G3)*
     &             (CF12ZL(I2G3,I2G4)*MCha(I2G3)*MCha(I2G4) - 
     &               CF12ZR(I2G3,I2G4)*MCha2(I2G3)))*
     &          (ReB0i(bb0,MZ2,MCha2(I2G3),MCha2(I2G4)))) - 
     &       (CF12ZL(I2G3,I2G4)*CF12ZL(I2G4,I2G3) + 
     &          CF12ZR(I2G3,I2G4)*CF12ZR(I2G4,I2G3))*
     &        (1/8.D0*(MZ2*(ReB0i(bb1,MZ2,MCha2(I2G3),
     &                MCha2(I2G4))) + (myA0(MCha2(I2G4)))) - 
     &          1/4.D0*(ReB0i(bb00,MZ2,MCha2(I2G3),MCha2(I2G4)))))

	ENDDo
	ENDDo

	Do I5G3= 1,5,1
	Do I5G4= 1,5,1

	dMZsq1 = dMZsq1 + 
     &    1/Pi**2*(1/16.D0*((CF11ZL(I5G4,I5G3)*
     &             (CF11ZR(I5G3,I5G4)*MNeu(I5G3)*MNeu(I5G4) - 
     &               CF11ZL(I5G3,I5G4)*MNeu2(I5G3)) + 
     &            CF11ZR(I5G4,I5G3)*
     &             (CF11ZL(I5G3,I5G4)*MNeu(I5G3)*MNeu(I5G4) - 
     &               CF11ZR(I5G3,I5G4)*MNeu2(I5G3)))*
     &          (ReB0i(bb0,MZ2,MNeu2(I5G3),MNeu2(I5G4)))) - 
     &       (CF11ZL(I5G3,I5G4)*CF11ZL(I5G4,I5G3) + 
     &          CF11ZR(I5G3,I5G4)*CF11ZR(I5G4,I5G3))*
     &        (1/16.D0*(MZ2*(ReB0i(bb1,MZ2,MNeu2(I5G3),
     &                MNeu2(I5G4))) + (myA0(MNeu2(I5G4)))) - 
     &          1/8.D0*(ReB0i(bb00,MZ2,MNeu2(I5G3),MNeu2(I5G4)))))

	ENDDo
	ENDDo

	Do I6G3= 1,6,1
	Do I6G4= 1,6,1

	dMZsq1 = dMZsq1 - 
     &    1/Pi**2*(1/8.D0*(ChhZ(I6G3,I6G4)**2*
     &          (ReB0i(bb00,MZ2,Masshh2(I6G3),Masshh(I6G4)**2))))

	ENDDo
	ENDDo
	
	Do I6G3= 1,1,1
	Do I6G4= 1,1,1

	dMZsq1 = dMZsq1 + 
     &    1/Pi**2*(1/8.D0*(ChhZ(I6G3,I6G4)**2*
     &          (ReB0i(bb00,MZ2,Masshh2(I6G3),Masshh(I6G4)**2))))

	ENDDo
	ENDDo 
	
		
	Do I6G3= 1,6,1
	Do I6G4= 1,6,1

	dMZsq1 = dMZsq1 - 
     &    1/Pi**2*(+
     &         1/4.D0*(CsemsepZ(I6G3,I6G4)*CsemsepZ(I6G4,I6G3)*
     &          (ReB0i(bb00,MZ2,MSe2(I6G3),MSe2(I6G4)))) + 
     &       3/4.D0*(CsdmsdpZ(I6G3,I6G4)*CsdmsdpZ(I6G4,I6G3)*
     &           (ReB0i(bb00,MZ2,MSd2(I6G3),MSd2(I6G4))) + 
     &          CsupsumZ(I6G3,I6G4)*CsupsumZ(I6G4,I6G3)*
     &           (ReB0i(bb00,MZ2,MSu2(I6G3),MSu2(I6G4)))))

	ENDDo
	ENDDo	

	dMZsq1 = dMZsq1 +(Alfa/(Pi*SW2)*
     &      (1/CW2*( + 
     &           1/16.D0*( - (myA0(aMH2)) )+ 
     &           1/4.D0*( + 
     &              (ReB0i(bb00,MZ2,aMH2,MZ2))) )  - 
     &        MW2/(4.D0*CW2**2)*(ReB0i(bb0,MZ2,aMH2,MZ2))))	
#endif
#if DEBUG >= 4
	print*, "dMZsq1", dMZsq1
#endif
#ifdef FORCHECKINGUV
	dZAA1 = Alfa/Pi*
     &    (5/4.D0*(ReB0i(bb0,0.D0,MW2,MW2)) + 
     &      1/2.D0*(MW2*(ReB0i(dbb0,0.D0,MW2,MW2)) + 
     &         (ReB0i(bb1,0.D0,MW2,MW2))) + 
     &      2*(ReB0i(dbb00,0.D0,MW2,MW2)))

	Do I2G3= 1,1,1

	dZAA1 = dZAA1 + 
     &    (-(1/(8.D0*Pi**2)*(CHmWpA(I2G3)**2*
     &           (ReB0i(dbb0,0.D0,MW2,MassHpm2(I2G3))))) + 
     &      Alfa/Pi*( + 
     &         (ReB0i(dbb00,0.D0,MassHpm2(I2G3),
     &           MassHpm2(I2G3))) ))

	ENDDo

	Do I3G3= 1,3,1

	dZAA1 = dZAA1 + 
     &    Alfa/Pi*(1/3.D0*(ReB0i(bb1,0.D0,MassFd2(I3G3),
     &          MassFd2(I3G3))) + 
     &       4/3.D0*(ReB0i(bb1,0.D0,MassFu2(I3G3),
     &          MassFu2(I3G3))) - 
     &       2/3.D0*(ReB0i(dbb00,0.D0,MassFd2(I3G3),
     &          MassFd2(I3G3))) - 
     &       8/3.D0*(ReB0i(dbb00,0.D0,MassFu2(I3G3),
     &          MassFu2(I3G3))) + 
     &       (ReB0i(bb1,0.D0,MassFe2(I3G3),MassFe2(I3G3))) - 
     &       2*(ReB0i(dbb00,0.D0,MassFe2(I3G3),MassFe2(I3G3))))
	ENDDo
#endif	
#ifdef aSM	
       aant1=ReB0i(bb0,0D0,MW2,MW2)
       aant2=ReB0i(bb1,0D0,MassFu2(3),MassFu2(3))
       aant3=ReB0i(bb1,0D0,MW2,MW2)
       aant4=ReB0i(dbb00,0D0,MassFu2(3),MassFu2(3))
       aant5=ReB0i(dbb00,0D0,MW2,MW2)
       dZAA1 =(Alfa*(15*aant1+2*(8*aant2+3*aant3-16*aant4+18*aant5
     &  )))/(12d0*Pi)
       abnt1=ReB0i(bb00,MZ2,MassFd2(3),MassFd2(3))
       abnt2=ReB0i(bb00,MZ2,MassFu2(2),MassFu2(2))
       abnt3=ReB0i(bb00,MZ2,MassFd2(1),MassFd2(1))
       abnt4=ReB0i(bb00,MZ2,MassFe2(1),MassFe2(1))
       abnt5=ReB0i(bb00,MZ2,MassFe2(3),MassFe2(3))
       abnt6=ReB0i(bb00,MZ2,MassFe2(2),MassFe2(2))
       abnt7=ReB0i(bb00,MZ2,MassFd2(2),MassFd2(2))
       abnt8=ReB0i(bb00,MZ2,MassFu2(1),MassFu2(1))
       abnt9=ReB0i(bb1,MZ2,MassFd2(3),MassFd2(3))
       abnt10=ReB0i(bb1,MZ2,MassFu2(2),MassFu2(2))
       abnt11=ReB0i(bb1,MZ2,MassFd2(1),MassFd2(1))
       abnt12=ReB0i(bb1,MZ2,MassFe2(1),MassFe2(1))
       abnt13=ReB0i(bb1,MZ2,MassFe2(3),MassFe2(3))
       abnt14=ReB0i(bb1,MZ2,MassFe2(2),MassFe2(2))
       abnt15=ReB0i(bb1,MZ2,MassFd2(2),MassFd2(2))
       abnt16=ReB0i(bb1,MZ2,MassFu2(1),MassFu2(1))
       abnt17=myA0(MassFd2(3))
       abnt18=myA0(MassFu2(2))
       abnt19=myA0(MassFd2(1))
       abnt20=myA0(MassFe2(1))
       abnt21=myA0(MassFe2(3))
       abnt22=myA0(MassFe2(2))
       abnt23=myA0(MassFd2(2))
       abnt24=myA0(MassFu2(1))
       dZAA1 =(Alfa*(-2*abnt1+abnt17+4*abnt18+abnt19-8*abnt2+3*
     &  abnt20+3*abnt21+3*abnt22+abnt23+4*abnt24-2*abnt3-6*abnt4-6*
     &  abnt5-6*abnt6-2*abnt7-8*abnt8+4*abnt10*MZ2+abnt11*MZ2+3*abnt12*
     &  MZ2+3*abnt13*MZ2+3*abnt14*MZ2+abnt15*MZ2+4*abnt16*MZ2+abnt9*
     &  MZ2))/(3d0*MZ2*Pi)+dZAA1   	
#endif

#ifdef aNMSSM
	Do I2G3= 2,2,1

	dZAA1 = dZAA1 + 
     &    (-(1/(8.D0*Pi**2)*(CHmWpA(I2G3)**2*
     &           (ReB0i(dbb0,0.D0,MW2,MassHpm2(I2G3))))) + 
     &      Alfa/Pi*( + 
     &         (ReB0i(dbb00,0.D0,MassHpm2(I2G3),
     &           MassHpm2(I2G3))) ))

	ENDDo
	Do I2G3= 1,2,1

	dZAA1 = dZAA1 + 
     &    (+ 
     &      Alfa/Pi*((ReB0i(bb1,0.D0,MCha2(I2G3),MCha2(I2G3)))  
     &          - 
     &         2*(ReB0i(dbb00,0.D0,MCha2(I2G3),MCha2(I2G3)))))

	ENDDo	

	Do I6G3= 1,6,1

	dZAA1 = dZAA1 + 
     & Alfa/Pi*(1/3.D0*(ReB0i(dbb00,0.D0,MSd2(I6G3),MSd2(I6G3)))+ 
     & 4/3.D0*(ReB0i(dbb00,0.D0,MSu2(I6G3),MSu2(I6G3))) + 
     & (ReB0i(dbb00,0.D0,MSe2(I6G3),MSe2(I6G3))))

	ENDDo
#endif
#if DEBUG >= 4
	print*, "dZAA1", dZAA1
#endif
#ifdef aSM
	dZZA1 = -(2/(MZ2*Pi**2)*
     &      (1/16.D0*((2*CWWZ*EL - 3*g2**2*S2W)*(myA0(MW2))) + 
     &        CWWZ*EL*(MW2/8.D0*(ReB0i(bb0,0.D0,MW2,MW2)) + 
     &           1/2.D0*(ReB0i(bb00,0.D0,MW2,MW2)))))
	Do I3G3= 1,3,1

	dZZA1 = dZZA1 - 
     &    2/(MZ2*Pi**2)*(EL*
     &       (1/8.D0*((CddZL + CddZR)*(myA0(MassFd2(I3G3))) + 
     &            (ctautauZL + ctautauZR)*(myA0(MassFe2(I3G3))))+
     &           1/4.D0*(-((CuuZL + CuuZR)*
     &               (myA0(MassFu2(I3G3)))) - 
     &            (CddZL + CddZR)*
     &             (ReB0i(bb00,0.D0,MassFd2(I3G3),MassFd2(I3G3)))
     &              - (ctautauZL + ctautauZR)*
     &             (ReB0i(bb00,0.D0,MassFe2(I3G3),MassFe2(I3G3)))
     &            ) + 1/2.D0*
     &          ((CuuZL + CuuZR)*
     &            (ReB0i(bb00,0.D0,MassFu2(I3G3),MassFu2(I3G3))))
     &         ))

	ENDDo           

	Do I2G3= 1,1,1

	dZZA1 = dZZA1 - 
     &    2/(MZ2*Pi**2)*(1/8.D0*
     &        (CHmWpA(I2G3)*CHmWpZ(I2G3)*
     &          (ReB0i(bb0,0.D0,MW2,MassHpm2(I2G3)))) + 
     &       EL*(1/4.D0*(CHpHmZ*
     &             (ReB0i(bb00,0.D0,MassHpm2(I2G3),
     &               MassHpm2(I2G3)))) )-
     &         1/64.D0*((2*C2W*g1*g2 - (g1**2 - g2**2)*S2W)*
     &          (myA0(MassHpm2(I2G3)))*
     &          (ZP(I2G3,1)**2 + ZP(I2G3,2)**2)))

	ENDDo	    
#endif

#ifdef aNMSSM
	Do I2G3= 2,2,1

	dZZA1 = dZZA1 - 
     &    2/(MZ2*Pi**2)*(1/8.D0*
     &        (CHmWpA(I2G3)*CHmWpZ(I2G3)*
     &          (ReB0i(bb0,0.D0,MW2,MassHpm2(I2G3)))) + 
     &       EL*(1/4.D0*(CHpHmZ*
     &             (ReB0i(bb00,0.D0,MassHpm2(I2G3),
     &               MassHpm2(I2G3)))) )-
     &         1/64.D0*((2*C2W*g1*g2 - (g1**2 - g2**2)*S2W)*
     &          (myA0(MassHpm2(I2G3)))*
     &          (ZP(I2G3,1)**2 + ZP(I2G3,2)**2)))

	ENDDo

	Do I2G3= 1,2,1

	dZZA1 = dZZA1 - 
     &    2/(MZ2*Pi**2)*(+ 
     &       EL*(+ 
     &          (CF12ZL(I2G3,I2G3) + CF12ZR(I2G3,I2G3))*
     &           (1/8.D0*(myA0(MCha2(I2G3))) - 
     &             1/4.D0*(ReB0i(bb00,0.D0,MCha2(I2G3),MCha2(I2G3))))))

	ENDDo

	Do I6G3= 1,6,1

	dZZA1 = dZZA1 + 
     &    2/(MZ2*Pi**2)*(1/16.D0*
     &        (CSemSepAZ(I6G3,I6G3)*(myA0(MSe2(I6G3)))) + 
     &       3/16.D0*(CSdmSdpAZ(I6G3,I6G3)*(myA0(MSd2(I6G3))) + 
     &          CSumSupAZ(I6G3,I6G3)*(myA0(MSu2(I6G3)))) - 
     &       EL*(1/4.D0*(CsdmsdpZ(I6G3,I6G3)*
     &              (ReB0i(bb00,0.D0,MSd2(I6G3),MSd2(I6G3))) + 
     &             CsemsepZ(I6G3,I6G3)*
     &              (ReB0i(bb00,0.D0,MSe2(I6G3),MSe2(I6G3)))) - 
     &          1/2.D0*(CsupsumZ(I6G3,I6G3)*
     &             (ReB0i(bb00,0.D0,MSu2(I6G3),MSu2(I6G3))))))

	ENDDo
#endif
#if DEBUG >= 4
	print*, "dZZA1", dZZA1
#endif


      addrun=  -(alfa*(myA0(MFd2(3)) + 4*myA0(MFu2(2)) + myA0(MFd2(1)) + 
     -       3*myA0(MFe2(1)) + 3*myA0(MFe2(2)) + myA0(MFd2(2)) + 
     -       3*myA0(MFe2(3)) + 4*myA0(MFu2(1)) - 
     -       2*ReB0i(bb00,MZ2,MFd2(3),MFd2(3)) - 
     -       8*ReB0i(bb00,MZ2,MFu2(2),MFu2(2)) - 
     -       2*ReB0i(bb00,MZ2,MFd2(1),MFd2(1)) - 
     -       6*ReB0i(bb00,MZ2,MFe2(1),MFe2(1)) - 
     -       6*ReB0i(bb00,MZ2,MFe2(2),MFe2(2)) - 
     -       2*ReB0i(bb00,MZ2,MFd2(2),MFd2(2)) - 
     -       6*ReB0i(bb00,MZ2,MFe2(3),MFe2(3)) - 
     -       8*ReB0i(bb00,MZ2,MFu2(1),MFu2(1)) - 
     -       MZ2*ReB0i(bb1,0d0,MFd2(3),MFd2(3)) - 
     -       4*MZ2*ReB0i(bb1,0d0,MFu2(2),MFu2(2)) - 
     -       MZ2*ReB0i(bb1,0d0,MFd2(1),MFd2(1)) - 
     -       3*MZ2*ReB0i(bb1,0d0,MFe2(1),MFe2(1)) - 
     -       3*MZ2*ReB0i(bb1,0d0,MFe2(2),MFe2(2)) - 
     -       MZ2*ReB0i(bb1,0d0,MFd2(2),MFd2(2)) - 
     -       3*MZ2*ReB0i(bb1,0d0,MFe2(3),MFe2(3)) - 
     -       4*MZ2*ReB0i(bb1,0d0,MFu2(1),MFu2(1)) + 
     -       MZ2*ReB0i(bb1,MZ2,MFd2(3),MFd2(3)) + 
     -       4*MZ2*ReB0i(bb1,MZ2,MFu2(2),MFu2(2)) + 
     -       MZ2*ReB0i(bb1,MZ2,MFd2(1),MFd2(1)) + 
     -       3*MZ2*ReB0i(bb1,MZ2,MFe2(1),MFe2(1)) + 
     -       3*MZ2*ReB0i(bb1,MZ2,MFe2(2),MFe2(2)) + 
     -       MZ2*ReB0i(bb1,MZ2,MFd2(2),MFd2(2)) + 
     -       3*MZ2*ReB0i(bb1,MZ2,MFe2(3),MFe2(3)) + 
     -       4*MZ2*ReB0i(bb1,MZ2,MFu2(1),MFu2(1)) + 
     -       2*MZ2*ReB0i(dbb00,0d0,MFd2(3),MFd2(3)) + 
     -       8*MZ2*ReB0i(dbb00,0d0,MFu2(2),MFu2(2)) + 
     -       2*MZ2*ReB0i(dbb00,0d0,MFd2(1),MFd2(1)) + 
     -       6*MZ2*ReB0i(dbb00,0d0,MFe2(1),MFe2(1)) + 
     -       6*MZ2*ReB0i(dbb00,0d0,MFe2(2),MFe2(2)) + 
     -       2*MZ2*ReB0i(dbb00,0d0,MFd2(2),MFd2(2)) + 
     -       6*MZ2*ReB0i(dbb00,0d0,MFe2(3),MFe2(3)) + 
     -       8*MZ2*ReB0i(dbb00,0d0,MFu2(1),MFu2(1))))/
     -      (6.*MZ2*pi)

	dSW1 = CW2/(2.D0*MW2*MZ2)*(-(MZ2*dMWsq1) + MW2*dMZsq1)/SW

#if DEBUG >= 4
	print*, "dSW1", dSW1
#endif

	dZe1 = -(1/(2.D0*CW)*(-(dZZA1*SW) + CW*dZAA1))+ addrun*0
	
#if DEBUG >= 4
	print*, "dZe1", dZe1
#endif



#ifdef aSM
	   dvex1=-(Alfa*(-1D0)*
     &       (Divergence + 4*CW2*Divergence- 2*Divergence*SW2 + 
     &         2*(-1 + 2*SW2)*myB0i(bb0,0D0,0D0,0D0) + 
     &         8*CW2*SW2*myB0i(bb0,0D0,0D0,MW2) + 
     &         8*CW2**2*myB0i(bb0,0D0,MW2,MZ2) - 
     &         2*MZ2*myC0(0D0,0D0,MZ2,Q2) + 
     &         4*MZ2*SW2*myC0(0D0,0D0,MZ2,Q2) + 
     &         16*CW2*SW2*myC00(0D0,0D0,MW2,Q2) + 
     &         4*myC00(0D0,0D0,MZ2,Q2) - 8*SW2*myC00(0D0,0D0,MZ2,Q2) + 
     &         16*CW2*myC00(0D0,MW2,MZ2,Q2) - 
     &         16*CW2*SW2*myC00(0D0,MW2,MZ2,Q2)))/(8.D0*CW2*Pi*SW2)  
#endif
#ifdef aNMSSM
	Do I2G5= 1,2,1
	Do I5G5= 1,5,1

	dvex1 = dvex1 - 
     &    SW2/(64.D0*Sqrt(2.D0)*Alfa*Pi**3)*
     &     (EL*cchinusnu(I5G5,2)*DCONJG(ctauchastauR(2,I2G5,2))*
     &        (2*DCONJG(CLF12F11W(I2G5,I5G5))*MCha(I2G5)*
     &           MNeu(I5G5)*
     &           myC0(MCha2(I2G5),MNeu2(I5G5),MSv2(2),Q2) + 
     &          DCONJG(CRF12F11W(I2G5,I5G5))*
     &           (Divergence - 
     &             2*(myB0i(bb0,0.D0,MCha2(I2G5),MNeu2(I5G5)) + 
     &                MSv2(2)*
     &                 myC0(MCha2(I2G5),MNeu2(I5G5),MSv2(2),Q2))+
     &               4*myC00(MCha2(I2G5),MNeu2(I5G5),MSv2(2),Q2)
     &             )))/SW

	ENDDo
	ENDDo
c         print*, "dvex1-neu-cha",dvex1 
	Do I5G5= 1,5,1
	Do I6G5= 1,6,1

	dvex1 = dvex1 + 
     &    SW2/(16.D0*Sqrt(2.D0)*Alfa*Pi**3)*
     &     (EL*cchinusnu(I5G5,2)*cchitaustauL(I5G5,2,I6G5)*
     &        CsesvW(I6G5,2)*
     &        (1/4.D0*Divergence + 
     &          myC00(MNeu2(I5G5),MSe2(I6G5),MSv2(2),Q2)))/SW

	ENDDo
	ENDDo
c         print*, "dvex1-neu-sn",dvex1 
	Do I2G5= 1,2,1
	Do I3G5= 1,3,1
	Do I5G5= 1,5,1

	dvex1 = dvex1 - 
     &    1/(32.D0*CW*Pi**2)*
     &     (ctauchastauR(1,I2G5,I3G5)*
     &       (2*CLF12F11W(I2G5,I5G5)*MCha(I2G5)*MNeu(I5G5)*
     &          myC0(MCha2(I2G5),MNeu2(I5G5),MSv2(I3G5),Q2) + 
     &         CRF12F11W(I2G5,I5G5)*
     &          (Divergence - 
     &            2*(myB0i(bb0,0.D0,MCha2(I2G5),MNeu2(I5G5)) + 
     &               MSv2(I3G5)*
     &                myC0(MCha2(I2G5),MNeu2(I5G5),MSv2(I3G5),Q2)
     &               ) + 4*
     &             myC00(MCha2(I2G5),MNeu2(I5G5),MSv2(I3G5),Q2)))
     &        *(-(CW*ZNC(I5G5,2)) + SW*ZNC(I5G5,1))*ZV(I3G5,1))

	ENDDo
	ENDDo
	ENDDo
c         print*, "dvex1-neu-cha-sne",dvex1 
	Do I2G5= 1,2,1
	Do I5G5= 1,5,1
	Do I6G5= 1,6,1

	dvex1 = dvex1 + 
     &    SW2/(64.D0*Sqrt(2.D0)*Alfa*Pi**3)*
     &     (EL*(DCONJG(cchitaustauL(I5G5,1,I6G5))*
     &           DCONJG(CF12F1S12(I2G5,1,I6G5))*
     &           (2*CRF12F11W(I2G5,I5G5)*MCha(I2G5)*MNeu(I5G5)*
     &              myC0(MCha2(I2G5),MNeu2(I5G5),MSe2(I6G5),Q2)+
     &               CLF12F11W(I2G5,I5G5)*
     &              (Divergence - 
     &                2*(myB0i(bb0,0.D0,MCha2(I2G5),MNeu2(I5G5)) + 
     &                   MSe2(I6G5)*
     &                    myC0(MCha2(I2G5),MNeu2(I5G5),
     &                     MSe2(I6G5),Q2)) + 
     &                4*myC00(MCha2(I2G5),MNeu2(I5G5),MSe2(I6G5),
     &                  Q2))) + 
     &          cchitaustauL(I5G5,2,I6G5)*CF12F1S12(I2G5,2,I6G5)*
     &           (2*DCONJG(CRF12F11W(I2G5,I5G5))*MCha(I2G5)*
     &              MNeu(I5G5)*
     &              myC0(MCha2(I2G5),MNeu2(I5G5),MSe2(I6G5),Q2)+
     &               DCONJG(CLF12F11W(I2G5,I5G5))*
     &              (Divergence - 
     &                2*(myB0i(bb0,0.D0,MCha2(I2G5),MNeu2(I5G5)) + 
     &                   MSe2(I6G5)*
     &                    myC0(MCha2(I2G5),MNeu2(I5G5),
     &                     MSe2(I6G5),Q2)) + 
     &                4*myC00(MCha2(I2G5),MNeu2(I5G5),MSe2(I6G5),
     &                  Q2)))))/SW

	ENDDo 
	ENDDo 
	ENDDo 
c         print*, "dvex1-neu-cha-sle",dvex1 
	Do I3G5= 1,3,1
	Do I5G5= 1,5,1
	Do I6G5= 1,6,1

	dvex1 = dvex1 + 
     &    1/(32.D0*CW*Pi**2)*
     &     (DCONJG(cchitaustauL(I5G5,1,I6G5))*
     &       DCONJG(CsesvW(I6G5,I3G5))*
     &       (Divergence + 
     &         4*myC00(MNeu2(I5G5),MSe2(I6G5),MSv2(I3G5),Q2))*
     &       (-(CW*ZNC(I5G5,2)) + SW*ZNC(I5G5,1))*ZV(I3G5,1))

	ENDDo 
	ENDDo 
	ENDDo 
c         print*, "dvex1-neu-cha-sne",dvex1 		
#endif	
#if DEBUG >= 4
	print*, "dvex1", dvex1
#endif

#ifdef aSM
	dZfnm1 = 1/Pi**2*
     &    (1/32.D0*((SW2*g1**2 + CW2*g2**2 + 2*CW*(g1*g2*SW))*
     &         (ReB0i(bb1,0.D0,0.D0,MZ2))) - 
     &      1/16.D0*(g2**2*((ReB0i(bb0,0.D0,0.D0,MW2)) + 
     &           (ReB0i(bb1,0.D0,MW2,0.D0)))))

#endif
#ifdef aNMSSM
	Do I5G3= 1,5,1

	dZfnm1 = dZfnm1 + 
     &    1/(16.D0*Sqrt(2.D0)*Pi**2)*
     &     (cchinusnu(I5G3,2)*
     &       (ReB0i(bb1,0.D0,MNeu2(I5G3),MSv2(2)))*
     &       (g1*ZNC(I5G3,1) - g2*ZNC(I5G3,2))*ZV(2,2))

	ENDDo 

	Do I2G3= 1,2,1
	Do I6G3= 1,6,1

	dZfnm1 = dZfnm1 + 
     &    1/(16.D0*Pi**2)*(CF12F1S12(I2G3,2,I6G3)*
     &       DCONJG(CF12F1S12(I2G3,2,I6G3))*
     &       (ReB0i(bb1,0.D0,MCha2(I2G3),MSe2(I6G3))))

	ENDDo 
	ENDDo 
#endif
#if DEBUG >= 4
	print*, "dZfnm1", dZfnm1
#endif

#ifdef aSM
	dZfne1 = 1/Pi**2*
     &    (1/32.D0*((SW2*g1**2 + CW2*g2**2 + 2*CW*(g1*g2*SW))*
     &         (ReB0i(bb1,0.D0,0.D0,MZ2))) - 
     &      1/16.D0*(g2**2*((ReB0i(bb0,0.D0,0.D0,MW2)) + 
     &           (ReB0i(bb1,0.D0,MW2,0.D0)))))
#endif
#ifdef aNMSSM
	Do I5G3= 1,5,1

	dZfne1 = dZfne1 + 
     &    1/(16.D0*Sqrt(2.D0)*Pi**2)*
     &     (cchinusnu(I5G3,1)*
     &       (ReB0i(bb1,0.D0,MNeu2(I5G3),MSv2(1)))*
     &       (g1*ZNC(I5G3,1) - g2*ZNC(I5G3,2))*ZV(1,1))

	ENDDo 

	Do I2G3= 1,2,1
	Do I6G3= 1,6,1

	dZfne1 = dZfne1 + 
     &    1/(16.D0*Pi**2)*(CF12F1S12(I2G3,1,I6G3)*
     &       DCONJG(CF12F1S12(I2G3,1,I6G3))*
     &       (ReB0i(bb1,0.D0,MCha2(I2G3),MSe2(I6G3))))

	ENDDo 
	ENDDo 
#endif	
#if DEBUG >= 4
	print*, "dZfne1", dZfne1
#endif

#ifdef aSM
	dZfmu1 = 1/Pi**2*
     &     (1/16.D0*(g2**2*(ReB0i(bb1,0.D0,0.D0,MW2))) - 
     &       1/8.D0*(ctautauZL**2*
     &          ((ReB0i(bb0,0.D0,0.D0,MZ2)) + (ReB0i(bb1,0.D0,MZ2,0.D0)))))
     &      - Alfa/(2.D0*Pi)*
     &     ((ReB0i(bb0,0.D0,0.D0,MW2)) + (ReB0i(bb1,0.D0,MW2,0.D0)))

#endif
#ifdef aNMSSM
	Do I2G3= 1,2,1
	Do I3G3= 1,3,1

	dZfmu1 = dZfmu1 + 
     &    1/(16.D0*Pi**2)*(DCONJG(ctauchastauR(2,I2G3,I3G3))*
     &       ctauchastauR(2,I2G3,I3G3)*
     &       (ReB0i(bb1,0.D0,MCha2(I2G3),MSv2(I3G3))))

	ENDDo
	ENDDo 

	Do I5G3= 1,5,1
	Do I6G3= 1,6,1

	dZfmu1 = dZfmu1 + 
     &    1/(16.D0*Pi**2)*(cchitaustauL(I5G3,2,I6G3)*
     &       DCONJG(cchitaustauL(I5G3,2,I6G3))*
     &       (ReB0i(bb1,0.D0,MNeu2(I5G3),MSe2(I6G3))))

	ENDDo 
	ENDDo 
#endif
#if DEBUG >= 4
	print*, "dZfmu1", dZfmu1
#endif
#ifdef aSM
	dZfe1 = 1/Pi**2*
     &     (1/16.D0*(g2**2*(ReB0i(bb1,0.D0,0.D0,MW2))) - 
     &       1/8.D0*(ctautauZL**2*
     &          ((ReB0i(bb0,0.D0,0.D0,MZ2)) + (ReB0i(bb1,0.D0,MZ2,0.D0)))))
     &      - Alfa/(2.D0*Pi)*
     &     ((ReB0i(bb0,0.D0,0.D0,MW2)) + (ReB0i(bb1,0.D0,MW2,0.D0)))
#endif
#ifdef aNMSSM
	Do I2G3= 1,2,1
	Do I3G3= 1,3,1

	dZfe1 = dZfe1 + 
     &    1/(16.D0*Pi**2)*(DCONJG(ctauchastauR(1,I2G3,I3G3))*
     &       ctauchastauR(1,I2G3,I3G3)*
     &       (ReB0i(bb1,0.D0,MCha2(I2G3),MSv2(I3G3))))

	ENDDo 
	ENDDo 

	Do I5G3= 1,5,1
	Do I6G3= 1,6,1

	dZfe1 = dZfe1 + 
     &    1/(16.D0*Pi**2)*(cchitaustauL(I5G3,1,I6G3)*
     &       DCONJG(cchitaustauL(I5G3,1,I6G3))*
     &       (ReB0i(bb1,0.D0,MNeu2(I5G3),MSe2(I6G3))))

	ENDDo 
	ENDDo 
#endif	
#if DEBUG >= 4
	print*, "dZfe1",dZfe1
#endif

#ifdef aSM   
	dbox11 = -((Alfa*MW2)/(8.D0*CW2*Pi*SW2)*
     &      (16*(1 - 2*SW2)*myD00(0D0,0D0,MW2,MZ2,Q2) + 
     &        2*((1 - 2*SW2)**2*
     &            (MZ2*myD0(0D0,0D0,MW2,MZ2,Q2) + myC0(0D0,0D0,MW2,Q2)) + 
     &           MW2*myD0(0D0,0D0,MW2,MZ2,Q2) + myC0(0D0,0D0,MZ2,Q2)) - 
     &        6*((1 - 2*SW2)**2*myD00(0D0,0D0,MW2,MZ2,Q2) + 
     &           myD00(0D0,0D0,MW2,MZ2,Q2))))

#endif

#ifdef aNMSSM
	Do I2G5= 1,2,1
	Do I3G5= 1,3,1
	Do I5G5= 1,5,1

	dbox11 = dbox11 - 
     &    (MW2*SW2)/(Sqrt(2.D0)*Alfa*Pi**3)*
     &     (EL*cchinusnu(I5G5,2)*DCONJG(ctauchastauR(2,I2G5,2))*
     &       ctauchastauR(1,I2G5,I3G5)*
     &       (1/(32.D0*CW)*ZNC(I5G5,1) - 1/32.D0*ZNC(I5G5,2)/SW)*
     &       myD00(MCha2(I2G5),MNeu2(I5G5),MSv2(2),MSv2(I3G5),
     &        Q2)*ZV(I3G5,1))

	ENDDo 
	ENDDo 
	ENDDo 

	Do I2G5= 1,2,1
	Do I5G5= 1,5,1
	Do I6G5= 1,6,1

	dbox11 = dbox11 - 
     &    (MW2*SW2)/(64.D0*Alfa*Pi**3)*
     &     (cchinusnu(I5G5,2)*DCONJG(cchitaustauL(I5G5,1,I6G5))*
     &       DCONJG(CF12F1S12(I2G5,1,I6G5))*
     &       DCONJG(ctauchastauR(2,I2G5,2))*MCha(I2G5)*
     &       MNeu(I5G5)*myD0(MCha2(I2G5),MNeu2(I5G5),MSe2(I6G5),
     &        MSv2(2),Q2))

	ENDDo 
	ENDDo 
	ENDDo 

	Do I2G5= 1,2,1
	Do I2G6= 1,2,1
	Do I3G5= 1,3,1
	Do I6G5= 1,6,1

	dbox11 = dbox11 - 
     &    (MW2*SW2)/(64.D0*Alfa*Pi**3)*
     &     (CF12F1S12(I2G6,2,I6G5)*
     &       DCONJG(CF12F1S12(I2G5,1,I6G5))*
     &       DCONJG(ctauchastauR(2,I2G5,I3G5))*
     &       ctauchastauR(1,I2G6,I3G5)*MCha(I2G5)*MCha(I2G6)*
     &       myD0(MCha2(I2G5),MCha2(I2G6),MSe2(I6G5),
     &        MSv2(I3G5),Q2))

	ENDDo 
	ENDDo 
	ENDDo 
	ENDDo 

	Do I2G5= 1,2,1
	Do I3G5= 1,3,1
	Do I5G5= 1,5,1
	Do I6G5= 1,6,1

	dbox11 = dbox11 - 
     &    (MW2*SW2)/(Sqrt(2.D0)*Alfa*Pi**3)*
     &     (EL*cchitaustauL(I5G5,2,I6G5)*CF12F1S12(I2G5,2,I6G5)*
     &       ctauchastauR(1,I2G5,I3G5)*
     &       (1/(64.D0*CW)*ZNC(I5G5,1) - 1/64.D0*ZNC(I5G5,2)/SW)*
     &       MCha(I2G5)*MNeu(I5G5)*
     &       myD0(MCha2(I2G5),MNeu2(I5G5),MSe2(I6G5),
     &        MSv2(I3G5),Q2)*ZV(I3G5,1))

	ENDDo 
	ENDDo 
	ENDDo 
	ENDDo 

	Do I2G5= 1,2,1
	Do I5G5= 1,5,1
	Do I6G5= 1,6,1
	Do I6G6= 1,6,1

	dbox11 = dbox11 - 
     &    (MW2*SW2)/(32.D0*Alfa*Pi**3)*
     &     (cchitaustauL(I5G5,2,I6G5)*CF12F1S12(I2G5,2,I6G5)*
     &       DCONJG(cchitaustauL(I5G5,1,I6G6))*
     &       DCONJG(CF12F1S12(I2G5,1,I6G6))*
     &       myD00(MCha2(I2G5),MNeu2(I5G5),MSe2(I6G5),
     &        MSe2(I6G6),Q2))

	ENDDo 
	ENDDo 
	ENDDo 
	ENDDo 

#endif

#ifdef check
          print*, "dbox11",dbox11  
	      print*, "analytic formular", -((EL/SW)**2*(5 - 10*SW2 + 2*SW2**2)*Log(MW2/MZ2))/(32.*Pi**2*SW2)
	      print*, "using SM file",-(Alfa*MW2*((1 - 2*SW2)**2*myC0(0D0,0D0,MW2,Q2) + myC0(0D0,0D0,MZ2,Q2) + 
     -       MW2*myD0(0D0,0D0,MW2,MZ2,Q2) + MZ2*myD0(0D0,0D0,MW2,MZ2,Q2) - 
     -       4*MZ2*SW2*myD0(0D0,0D0,MW2,MZ2,Q2) + 4*MZ2*SW2**2*myD0(0D0,0D0,MW2,MZ2,Q2) + 
     -       2*myD00(0D0,0D0,MW2,MZ2,Q2) - 4*SW2*myD00(0D0,0D0,MW2,MZ2,Q2) - 
     -       12*SW2**2*myD00(0D0,0D0,MW2,MZ2,Q2)))/(4.*CW2*Pi*SW2) 
        print*, myC0(0D0,0D0,MW2,Q2),1D0/MW2 + Log(Q2/MW2)/MW2
        print*, "myD0(0D0,0D0,MW2,MZ2)",myD0(0D0,0D0,MW2,MZ2,Q2),-(1/(MW2*MZ2)) - Log(MW2/MZ2)/((MW2 - MZ2)*MZ2) - Log(Q2/MW2)/(MW2*MZ2)
      print*, "vb",dbox11 + dvex1 + 0.5*dZfe1 + 0.5*dZfmu1 + 0.5*dZfne1 + 
     -  0.5*dZfnm1+ 1./SW/CW*dZZA1
      print*, "delta alpha", 2*dZe1 - 1./SW/CW*dZZA1
      print*, "- (2*dSW1)/SW",- (2*dSW1)/SW,  2D0/SW/CW*dZZA1/MZ2
      print*, "+ dMW0/MW2 - dMWsq1/MW2 ",+ dMW0/MW2 - dMWsq1/MW2         
#endif
    
	delR = DelAlfa0+ dbox11 + dvex1 + 0.5*dZfe1 + 0.5*dZfmu1 + 0.5*dZfne1 + 
     -  0.5*dZfnm1 + 2*dZe1 + dMW0/MW2 - dMWsq1/MW2 - (2*dSW1)/SW

#if DEBUG >= 4
	print*, "delR", delR
#endif
	end

