
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      double complex function selfCH(ix,jx,p2)
      
      implicit none 
      integer ix,jx,iself,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,Indexdelta(2,2)

      integer bb0,bb1,bb00,dbb0,dbb1,dbb00
      common /funcID/ bb0,bb1,bb00,dbb0,dbb1,dbb00

      double precision P2,myA0,afac
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)     
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
    
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      double complex myB0i
#include "HdecayTCLs.inc"
       IndexDelta(1,1)=1
       IndexDelta(2,1)=0
       IndexDelta(1,2)=0             
       IndexDelta(2,2)=1
       selfCH=0D0      
       afac= 1D0/16D0/pi**2

       selfCH=selfCH+(4*myA0(MW2)*CHmHpWW(ix,jx)+4*myB0i(bb0,p2,0D0,MW2)*
     &  CHmWpA(ix)*CHmWpA(jx)+myB0i(bb0,p2,MW2,MZ2)*(CHmU3U1(jx)*
     &  CHmU3U2(ix)+CHmU3U1(ix)*CHmU3U2(jx)+4*CHmWpZ(ix)*CHmWpZ(jx))+2*
     &  myA0(MZ2)*CHpHmZZ(ix,jx)-CHpHmZ**2*myA0(MZ2)*IndexDelta(ix,jx)-3*e*
     &  *2*p2*myB0i(bb0,p2,0D0,MassHpm(ix)**2)*IndexDelta(ix,jx)-3*
     &  CHpHmZ**2*p2*myB0i(bb0,p2,MZ2,MassHpm(ix)**2)*IndexDelta(ix,jx)-
     &  2*e**2*p2*myB0i(bb1,p2,0D0,MassHpm(ix)**2)*IndexDelta(ix,jx)-2*
     &  CHpHmZ**2*p2*myB0i(bb1,p2,MZ2,MassHpm(ix)**2)*IndexDelta(ix,jx)-
     &  e**2*myB0i(bb0,p2,0D0,MassHpm(ix)**2)*IndexDelta(ix,jx)*
     &  MassHpm(ix)**2-CHpHmZ**2*myB0i(bb0,p2,MZ2,MassHpm(ix)**2)*
     &  IndexDelta(ix,jx)*MassHpm(ix)**2)
  
           do I2G3 = 1,2
       selfCH=selfCH-(myA0(MassHpm(I2G3)**2)*C2HmHp(ix,I2G3,jx,I2G3))
           enddo
c         print*, "selfCH",selfCH*afac
c         selfCH=0D0                      
           do I2G3 = 1,2
           do I6G3 = 1,6
       selfCH=selfCH-(myB0i(bb0,p2,Masshh(I6G3)**2,MassHpm(I2G3)**2)*
     &  ChHmHp(I2G3,jx,I6G3)*ChHmHp(ix,I2G3,I6G3))
           enddo
           enddo   
                       
           do I6G3 = 1,6
       selfCH=selfCH+((IC*myA0(Masshh(I6G3)**2)*ChhHmHp(ix,I6G3,jx,I6G3))
     &  /2d0+myA0(MW2)*ChHmWp(ix,I6G3)*ChHpWm(I6G3,jx)+3*p2*
     &  myB0i(bb0,p2,MW2,Masshh(I6G3)**2)*ChHmWp(ix,I6G3)*ChHpWm(I6G3,jx)
     &  +2*p2*myB0i(bb1,p2,MW2,Masshh(I6G3)**2)*ChHmWp(ix,I6G3)*
     &  ChHpWm(I6G3,jx)+myB0i(bb0,p2,MW2,Masshh(I6G3)**2)*
     &  ChHmWp(ix,I6G3)*ChHpWm(I6G3,jx)*Masshh(I6G3)**2)
           enddo
           
c         print*, "selfCH",selfCH*afac
c         selfCH=0D0             
          
           do I3G3 = 1,3
       selfCH=selfCH+(-2*
     &  CtaunuHpR(I3G3,ix)*CtaunuHpR(I3G3,jx)*(myA0(MassFe(I3G3)**2)-p2*
     &  myB0i(bb1,p2,MassFe(I3G3)**2,0D0)+
     &  myB0i(bb0,p2,MassFe(I3G3)**2,0D0)*(-p2+0D0)))
           enddo
          
           do I3G3 = 1,3
           do I3G4 = 1,3
       selfCH=selfCH-6*(myA0(MassFd(I3G4)**2)*(CtbHpL(I3G3,I3G4,jx)*
     &  DCONJG(CtbHpL(I3G3,I3G4,ix))+CtbHpR(I3G3,I3G4,jx)*
     &  DCONJG(CtbHpR(I3G3,I3G4,ix)))-p2*myB0i(bb1,p2,MassFd(I3G4)**
     &  2,MassFu(I3G3)**2)*(CtbHpL(I3G3,I3G4,jx)*
     &  DCONJG(CtbHpL(I3G3,I3G4,ix))+CtbHpR(I3G3,I3G4,jx)*
     &  DCONJG(CtbHpR(I3G3,I3G4,ix)))+myB0i(bb0,p2,MassFd(I3G4)**
     &  2,MassFu(I3G3)**2)*(CtbHpL(I3G3,I3G4,jx)*
     &  (DCONJG(CtbHpR(I3G3,I3G4,ix))*MassFd(I3G4)*MassFu(I3G3)+
     &  DCONJG(CtbHpL(I3G3,I3G4,ix))*(-p2+MassFu(I3G3)**2))+
     &  CtbHpR(I3G3,I3G4,jx)*(DCONJG(CtbHpL(I3G3,I3G4,ix))*MassFd(I3G4)
     &  *MassFu(I3G3)+DCONJG(CtbHpR(I3G3,I3G4,ix))*(-p2+MassFu(I3G3)**
     &  2))))
           enddo
           enddo
c         print*, "selfCH F",selfCH*afac
c         selfCH=0D0           
           do I2G3 = 1,2
           do I5G3 = 1,5
       selfCH=selfCH+2*(myA0(MCha2(I2G3))*(CLHpChiCha(I5G3,I2G3,jx)*
     &  CRHmChiCha(I2G3,I5G3,ix)+CLHmChiCha(I2G3,I5G3,ix)*
     &  CRHpChiCha(I5G3,I2G3,jx))-p2*myB0i(bb1,p2,MCha2(I2G3),MNeu2(I5G3)
     &  )*(CLHpChiCha(I5G3,I2G3,jx)*CRHmChiCha(I2G3,I5G3,ix)+
     &  CLHmChiCha(I2G3,I5G3,ix)*CRHpChiCha(I5G3,I2G3,jx))+
     &  myB0i(bb0,p2,MCha2(I2G3),MNeu2(I5G3))*(CRHpChiCha(I5G3,I2G3,jx)*
     &  (CRHmChiCha(I2G3,I5G3,ix)*MCha(I2G3)*MNeu(I5G3)+
     &  CLHmChiCha(I2G3,I5G3,ix)*(-p2+MNeu2(I5G3)))+
     &  CLHpChiCha(I5G3,I2G3,jx)*(CLHmChiCha(I2G3,I5G3,ix)*MCha(I2G3)*
     &  MNeu(I5G3)+CRHmChiCha(I2G3,I5G3,ix)*(-p2+MNeu2(I5G3)))))
           enddo
           enddo
c         print*, "selfCH CHA",selfCH*afac
c         selfCH=0D0    


         
           do I3G3 = 1,3
       selfCH=selfCH+(IC*myA0(MSv(I3G3)**2)*CHmHpSvSv(I3G3,ix,I3G3,jx))
           enddo         
          
            do I6G3 = 1,6
       selfCH=selfCH+(+3*IC*myA0(MSd(I6G3)**2)*
     &  CHmHpSdmSdp(I6G3,ix,I6G3,jx)+IC*myA0(MSe(I6G3)**2)*
     &  CHmHpSemSep(I6G3,ix,I6G3,jx)+3*IC*myA0(MSu(I6G3)**2)*
     &  CHmHpSupSum(I6G3,ix,I6G3,jx))
           enddo
          
           do I3G3 = 1,3
           do I6G3 = 1,6
       selfCH=selfCH-(myB0i(bb0,p2,MSe(I6G3)**2,MSv(I3G3)**2)*
     &  CHmSepSv(I3G3,I6G3,ix)*CHpSemSv(I6G3,I3G3,jx))
           enddo
           enddo

           do I6G3 = 1,6
           do I6G4 = 1,6
       selfCH=selfCH-3*myB0i(bb0,p2,MSd(I6G4)**2,MSu(I6G3)**2)*
     &  CHmSupSdp(I6G3,I6G4,ix)*CHpSumSdm(I6G4,I6G3,jx)
           enddo
           enddo
c         print*, "selfCH",selfCH*afac
c         selfCH=0D0           
       selfCH=selfCH*afac       
      
      
      end
