c#define printdetails
      subroutine ini_SM(aMH,aMT,aMW,aMZ,aalfa,aQ2,delrho1LS,dMT1,
     &        ischeme)
      implicit none
      integer ischeme
      double precision aMH,aMT,aMZ,aalfa,aMW,aQ2,delrho1LS,dMT1     
#include "SM.h"
      MHSM=aMH; M1=aMT; MZ=aMZ; alfa=aalfa
      MH2=MHSM**2; Q2=aQ2
      M12=M1**2
      CW =aMW/aMZ
      CW2=CW**2
      SW2=1.-CW2; SW=Sqrt(SW2)
      v= 2D0*MZ*SW*CW/Sqrt(4*Pi*alfa)
      vv=v
      vv2=vv**2   
      call CTermOL_SMEW(ischeme)   
      delrho1LS= -dMZSM(2)*dMZSM(2) +(dMZSM(2)*dMWSM(2)) 
      dMT1= dMTSM(2)
      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
      subroutine CTermOL_SMEW(ischeme)
      implicit none
      integer ischeme
      double complex B0P,B1P
      double precision C0T,CEpT,K0T0,I0A
      double precision aB0P1,aB1P1,afac,AEpT  
      logical CPcon,MHpmInput,onelswitch,mQrun      
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch          
#include "SM.h" 
       LogMH=Log(MH2/Q2);LogM12=Log(M12/Q2)
       aintsm8=C0T(MH2,MH2,0D0,Q2)
       aintsm9=C0T(0D0,0D0,MH2,Q2)
       aintsm11=CEpT(MH2,MH2,0D0,Q2)
       aintsm12=CEpT(0D0,0D0,MH2,Q2)
       aintsm13=-3*AEpT(MH2,Q2)+I0A(MH2,MH2,MH2,Q2)
       ak0tsm1=- AEpT(MH2,Q2)- AEpT(M12,Q2)+I0A(0D0,MH2,M12,Q2)
       ak0tsm2=- AEpT(M12,Q2)+I0A(0D0,0D0,M12,Q2)
       ak0tsm3=-AEpT(MH2,Q2)-2*AEpT(M12,Q2)+I0A(MH2,M12,M12,Q2)
       ak0tsm4=-2* AEpT(M12,Q2)+I0A(0D0,M12,M12,Q2)
       aB0P1=DBLE(B0P(M12,MH2,M12,Q2))
       aB1P1=DBLE(B1P(M12,MH2,M12,Q2))
       dMTSM(1)=(3*M1**3)/(32.*Pi**2*vv**2)  
       if(ischeme.eq.1)then
       dMTSM(2)=0D0
       else  
       dMTSM(2)=(M1**3*(1+4*aB0P1+2*aB1P1))/(32.*Pi**2*vv2)
       endif
       afac=1./pi**2

       dMZSM(1)=afac*(-3*M1**2)/(8.*vv2)     
       dMZSM(2)=-afac*(-12*LogM12*M1**2+MH2)/(32.*vv2)      
       
       dMWSM(1)=afac*(-3*M1**2)/(8.*vv2)    
       dMWSM(2)=-afac*((6-12*LogM12)*M1**2+MH2)/(32.*vv2)     

       dSWSM(1)=- CW**2/SW/2D0 *(dMWSM(1)-dMZSM(1) ) 
       dSWSM(2)=- CW**2/SW/2D0 *(dMWSM(2)-dMZSM(2) )  
#ifdef aaaa            
       dMHSM(1)=afac*(3*(-24*M1**4+5*MH2**2))/(32.*vv2)        
       dMHSM(2)=afac*(3*(8*(-1+3*LogM12)*M1**4-(-1+4*LogMH+Logx)*MH2**2))/(32.*vv2)          
       dTHSM(1)=-afac*(3*(-8*M1**4+MH2**2))/(32.*vv)       
       dTHSM(2)=-afac*(3*(8*(-1+LogM12)*M1**4-(-1+LogMH)*MH2**2))/(32.*vv)  
       dZGpSM(1)=(-3*M12)/(8.*Pi**2*vv2)
       dZGpSM(2)=-(-3*M12 + 6*(1 - LogM12)*M12 + MH2/2.)/(16.*Pi**2*vv**2)
       dZG0SM(1)=(-3*M12)/(8.*Pi**2*vv2)
       dZG0SM(2)=-(-3*M12 + 6*(1 - LogM12)*M12 + MH2/2.)/(16.*Pi**2*vv**2)  
#endif   
c#define printdetails 
#ifdef printdetails
       write(*,*)aintsm8, aintsm9, aintsm11, aintsm12, aintsm13, ak0tsm1, 
     .   ak0tsm2,ak0tsm3, ak0tsm4
       write(*,*) "dMTSM =",dMTSM(1),"/Epsilon + ",dMTSM(2)
       write(*,*) "dMZSM =",dMZSM(1),"/Epsilon + ",dMZSM(2)    
       write(*,*) "dMWSM =",dMWSM(1),"/Epsilon + ",dMWSM(2)  
       write(*,*) "dMHSM =",dMHSM(1),"/Epsilon + ",dMHSM(2)     
       write(*,*) "dTHSM =",dTHSM(1),"/Epsilon + ",dTHSM(2)  
       write(*,*) "dSWSM =",dSWSM(1),"/Epsilon + ",dSWSM(2)
      print*, "-2*dMZSM(2)*dMZSM(1) +(dMZSM(1)*dMWSM(2)+dMZSM(2)*dMWSM(1))" 
      print*, -2*dMZSM(2)*dMZSM(1) +(dMZSM(1)*dMWSM(2)+dMZSM(2)*dMWSM(1))       
       print*, "oneloop deltarho CT",(3/16D0*2*M1*dMTSM(1))/vv2/pi**2

       print*, "-2*dMZSM(2)*dMZSM(1) +(dMZSM(1)*dMWSM(2)+dMZSM(2)*dMWSM(1))" 
       print*, -2*dMZSM(2)*dMZSM(1) +(dMZSM(1)*dMWSM(2)+dMZSM(2)*dMWSM(1)) 

#endif                     
      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      

      subroutine SelfTWW2L_SMEW(selfWDP,selfWSP,selfW)
      implicit none
      double precision selfWDP,selfWSP,selfW
      double precision selfWCTDP,selfWCTSP,selfWCT
      double precision afac,afac2      
#include "SM.h" 
         afac= 1./16D0/pi**4/vv2**2
         afac2= 1./16D0/pi**2/vv2**2
         selfWDP=0D0;selfWSP=0D0;selfW=0D0
         selfWCTDP=0D0;selfWCTSP=0D0;selfWCT=0D0
       selfWDP=0+selfWDP
       selfWSP=((3-LogMH+Logx)*MH2**2)/32.+selfWSP
       selfW=(-((-1+LogMH)*Logx*MH2**2)/32.-(Logx**2*MH2**2)/64.+(MH2**
     &  2*(66-84*LogMH+18*LogMH**2+Pi**2))/384.)+selfW
#ifdef printdetails
       write(*,110) "selfW[1]=",selfWDP*afac,"/Epsilon^2+",selfWSP*afac,"/Epsilon+",selfW*afac
       selfWDP=0D0;selfWSP=0D0;selfW=0D0
110   format(A,F24.14,A,F24.14,A,F24.14)       
#endif
       selfWDP=0+selfWDP
       selfWSP=-((-15+4*LogMH-4*logx)*MH2**2)/64.+selfWSP
        
       selfW=selfW+-(MH2*(36*aintsm13+MH2*(123+72*LogMH**2+24*
     &  LogMH*(-5+logx)-24*logx+12*logx**2+4*Pi**2+42*Zeta2)))/384.
#ifdef printdetails
       write(*,110) "selfW[2]=",selfWDP*afac,"/Epsilon^2+",selfWSP*afac,"/Epsilon+",selfW*afac
       selfWDP=0D0;selfWSP=0D0;selfW=0D0      
#endif  

       selfWDP=(9*M1**4)/16.+selfWDP
       selfWSP=(-3*M1**2*((21+12*LogM12-8*LogMH+4*logx+4*Logx)*M1**2-2*
     &  MH2))/32.+selfWSP
        
        !finite
        
       selfW=selfW+(-12*ak0tsm2*M12*(6*M12+MH2)+36*ak0tsm1*(2*M12**2-3*
     &  M12*MH2+MH2**2)+MH2*(36*ak0tsm3*(2*M12-MH2)+M12*(-6*MH2*(29+3*
     &  LogM12**2+6*LogM12*(-2+LogMH)-20*LogMH+3*LogMH**2+6*Zeta2)+M12*
     &  (-159+60*LogM12**2+48*LogMH+12*LogMH**2-24*logx-24*Logx+12*
     &  Logx**2+12*LogM12*(-3+2*LogMH+2*logx+2*Logx)+12*logx2-2*Pi**2+
     &  72*Zeta2))))/(64.*MH2)
      
#ifdef printdetails
       write(*,110) "selfW[3]=",selfWDP*afac,"/Epsilon^2+",selfWSP*afac,"/Epsilon+",selfW*afac
       selfWDP=0D0;selfWSP=0D0;selfW=0D0      
#endif   
       selfWCTDP=0+selfWCTDP
       selfWCTSP=selfWCTSP+(vv*(2*MH2*vv*dSWSM(1)+SW*(-(vv*dMHSM(1))+
     &  (3-2*LogMH+2*Logx)*dTHSM(1))))/(2.*SW)
        
        !finite
        
       selfWCT=selfWCT+(vv*(6*MH2*vv*((3-2*LogMH)*dSWSM(1)+2*dSWSM(2))+
     &  SW*((21-18*LogMH+6*LogMH**2-6*Logx**2+Pi**2)*dTHSM(1)+6*(3-2*
     &  LogMH+2*Logx)*dTHSM(2)+vv*((-3+6*LogMH)*dMHSM(1)-6*dMHSM(2)+
     &  MH2*Pi**2*dZGpSM(1)))))/(12.*SW)
     
#ifdef printdetails
       write(*,110) "selfWCT[1]=",selfWCTDP*afac2,"/Epsilon^2+",selfWCTSP*afac2,"/Epsilon+",selfWCT*afac2
       selfWCTDP=0D0;selfWCTSP=0D0;selfWCT=0D0      
#endif     

       selfWCTDP=selfWCTDP+(12*M1*vv**2*(-(SW*dMTSM(1))+M1*dSWSM(1)))/SW
       selfWCTSP=selfWCTSP+(6*M1*vv**2*(SW*(dMTSM(1)+2*LogM12*dMTSM(1)-
     &  2*dMTSM(2))+M1*(dSWSM(1)-2*LogM12*dSWSM(1)+2*dSWSM(2))))/SW
        
        !finite
        
       selfWCT=selfWCT+(-3*M1*vv**2*(SW*((-1+2*LogM12+2*LogM12**2+2*
     &  Zeta2)*dMTSM(1)-2*(1+2*LogM12)*dMTSM(2))+2*(-1+2*LogM12)*M1*
     &  dSWSM(2)))/SW
#ifdef printdetails
       write(*,110) "selfWCT[3]=",selfWCTDP*afac2,"/Epsilon^2+",selfWCTSP*afac2,"/Epsilon+",selfWCT*afac2
       selfWCTDP=0D0;selfWCTSP=0D0;selfWCT=0D0      
#endif 

        selfW=selfW*afac+selfWCT*afac2  
        selfWSP=selfWSP*afac+selfWCTSP*afac2        
        selfWDP=selfWDP*afac+selfWCTDP*afac2      
      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine SelfTZZ2L_SMEW(selfZDP,selfZSP,selfZ)
      implicit none
      double precision selfZDP,selfZSP,selfZ
      double precision selfZCTDP,selfZCTSP,selfZCT
      double precision afac,afac2

#include "SM.h"  
         afac= 1./16D0/pi**4/vv2**2
         afac2= 1./16D0/pi**2/vv2**2
         selfZDP=0D0;selfZSP=0D0;selfZ=0D0
         selfZCTDP=0D0;selfZCTSP=0D0;selfZCT=0D0
       selfZDP=0+selfZDP
       selfZSP=((3-LogMH+Logx)*MH2**2)/32.+selfZSP
       selfZ=(-((-1+LogMH)*Logx*MH2**2)/32.-(Logx**2*MH2**2)/64.+(MH2**
     &  2*(66-84*LogMH+18*LogMH**2+Pi**2))/384.)+selfZ
            
#ifdef printdetails
       write(*,110) "selfZ[1]=",selfZDP*afac,"/Epsilon^2+",selfZSP*afac,"/Epsilon+",selfZ*afac
       selfZDP=0D0;selfZSP=0D0;selfZ=0D0
110   format(A,F24.14,A,F24.14,A,F24.14)       
#endif
       selfZDP=0+selfZDP
       selfZSP=((15-4*LogMH+4*Logx)*MH2**4)/(64.*MH2**2)+selfZSP
        
        !finite
        
       selfZ=selfZ+-(MH2*(36*aintsm13+MH2*(123+72*LogMH**2+24*LogMH*(-
     &  5+Logx)-24*Logx+12*Logx**2+2*Pi**2+54*Zeta2)))/384.
     
#ifdef printdetails
       write(*,110) "selfZ[2]=",selfZDP*afac,"/Epsilon^2+",selfZSP*afac,"/Epsilon+",selfZ*afac
       selfZDP=0D0;selfZSP=0D0;selfZ=0D0      
#endif  

       selfZDP=selfZDP+(3*M1**4*(1+2*CW**2+2*SW2))/16.
       selfZSP=selfZSP+(3*M1**2*(2*MH2+M1**2*(-25+4*CW**4-4*LogM12+8*
     &  LogMH-8*Logx+4*SW**4-6*SW2-8*LogM12*SW2+CW**2*(-6-8*LogM12+8*
     &  SW2))))/32. 
        
        !finite
        
       selfZ=selfZ+(3*M12*(24*ak0tsm3*M12+180*M12**2+376*CW**2*M12**2-
     &  80*CW**4*M12**2-112*LogM12*M12**2-288*CW**2*LogM12*M12**2+64*
     &  CW**4*LogM12*M12**2-64*LogM12**2*M12**2-256*LogMH*M12**2+64*
     &  LogM12*LogMH*M12**2+32*LogMH**2*M12**2+64*Logx*M12**2-64*
     &  LogM12*Logx*M12**2-32*Logx**2*M12**2+25*M12*MH2-94*CW**2*M12*
     &  MH2+20*CW**4*M12*MH2-8*LogM12*M12*MH2+72*CW**2*LogM12*M12*MH2-
     &  16*CW**4*LogM12*M12*MH2+16*LogM12**2*M12*MH2+24*LogMH*M12*MH2+
     &  8*LogM12*LogMH*M12*MH2+4*LogMH**2*M12*MH2-16*Logx*M12*MH2+16*
     &  LogM12*Logx*M12*MH2+8*Logx**2*M12*MH2+14*MH2**2-8*LogMH*MH2**2+
     &  6*ak0tsm4*(-4*M12+MH2)-80*M12**2*SW**4+64*LogM12*M12**2*SW**4+
     &  20*M12*MH2*SW**4-16*LogM12*M12*MH2*SW**4+376*M12**2*SW2-160*CW*
     &  *2*M12**2*SW2-288*LogM12*M12**2*SW2+128*CW**2*LogM12*M12**2*
     &  SW2-94*M12*MH2*SW2+40*CW**2*M12*MH2*SW2+72*LogM12*M12*MH2*SW2-
     &  32*CW**2*LogM12*M12*MH2*SW2-8*ak0tsm2*(-4*M12+MH2)*(-1+2*CW**2+
     &  2*SW2)-32*M12**2*Zeta2+26*M12*MH2*Zeta2))/(64.*(-4*M12+MH2))
     
     
       
#ifdef printdetails
       write(*,110) "selfZ[3]=",selfZDP*afac,"/Epsilon^2+",selfZSP*afac,"/Epsilon+",selfZ*afac
       selfZDP=0D0;selfZSP=0D0;selfZ=0D0      
#endif   
       selfZCTDP=0+selfZCTDP
       selfZCTSP=selfZCTSP+(vv*(vv*(-dMHSM(1)+(2*MH2*dSWSM(1))/SW-(2*
     &  MH2*SW*dSWSM(1))/CW**2)+(3-2*LogMH+2*Logx)*dTHSM(1)))/2.
        
        !finite
        
       selfZCT=selfZCT+(vv*(6*MH2*SW**2*vv*((-3+2*LogMH)*dSWSM(1)-2*
     &  dSWSM(2))+CW**2*(6*MH2*vv*((3-2*LogMH)*dSWSM(1)+2*dSWSM(2))+SW*
     &  ((21-18*LogMH+6*LogMH**2-6*Logx**2+Pi**2)*dTHSM(1)+6*(3-2*
     &  LogMH+2*Logx)*dTHSM(2)+vv*((-3+6*LogMH)*dMHSM(1)-6*dMHSM(2)+
     &  MH2*Pi**2*dZG0SM(1))))))/(12.*CW**2*SW)
     
#ifdef printdetails
       write(*,110) "selfZCT[1]=",selfZCTDP*afac2,"/Epsilon^2+",selfZCTSP*afac2,"/Epsilon+",selfZCT*afac2
       selfZCTDP=0D0;selfZCTSP=0D0;selfZCT=0D0      
#endif     
       selfZCTDP=selfZCTDP+(-12*M1*vv**2*(M1*SW2*dSWSM(1)+CW**2*(SW*
     &  dMTSM(1)-M1*dSWSM(1))))/(CW**2*SW)
       selfZCTSP=selfZCTSP+(2*M1*vv**2*(18*M1*M12*SW2*(LogM12*dSWSM(1)-
     &  dSWSM(2))+CW**2*(M1**2*SW*(9-32*SW**4+24*SW2)*dMTSM(1)+M12*(-
     &  24*SW**3*dMTSM(1)+32*SW**5*dMTSM(1)+9*SW*(dMTSM(1)+2*LogM12*
     &  dMTSM(1)-2*dMTSM(2))+18*M1*(-(LogM12*dSWSM(1))+dSWSM(2))))))
     &  /(3.*CW**2*M12*SW)
        
        !finite
        
       selfZCT=selfZCT+-(M1*vv**2*(-36*LogM12*M1*M12*SW2*dSWSM(2)+CW**
     &  2*(M1**2*SW*((9+32*SW**4-24*SW2+LogM12*(18-64*SW**4+48*SW2))*
     &  dMTSM(1)+2*(-9+32*SW**4-24*SW2)*dMTSM(2))+M12*(32*SW**5*((-1+2*
     &  LogM12)*dMTSM(1)-2*dMTSM(2))+24*SW**3*(dMTSM(1)-2*LogM12*
     &  dMTSM(1)+2*dMTSM(2))+9*SW*((-1+2*LogM12+2*LogM12**2+2*Zeta2)*
     &  dMTSM(1)-2*(1+2*LogM12)*dMTSM(2))+36*LogM12*M1*dSWSM(2)))))
     &  /(3.*CW**2*M12*SW)
#ifdef printdetails
       write(*,110) "selfZCT[3]=",selfZCTDP*afac2,"/Epsilon^2+",selfZCTSP*afac2,"/Epsilon+",selfZCT*afac2
       selfZCTDP=0D0;selfZCTSP=0D0;selfZCT=0D0      
#endif 
        selfZ=selfZ*afac+selfZCT*afac2     
        selfZSP=selfZSP*afac+selfZCTSP*afac2        
        selfZDP=selfZDP*afac+selfZCTDP*afac2        
      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine SelfTVV_QCDSM(deltarho2LQCD,ischeme)
      implicit none
      integer ist2,ist3,ist4,ist5,ist6,ischeme
      double precision selfZDP,selfZSP,selfZ,deltarho2LQCD
      double precision selfZCTDP,selfZCTSP,selfZCT
      double precision selfWDP,selfWSP,selfW
      double precision selfWCTDP,selfWCTSP,selfWCT      
      double precision fac,ctfac,SW2,CW2,aBfunc(3),C0T,B0T,CEpT,BEpT,A0T,AEpT
      double complex B0P,BEpP   
      logical CPcon,MHpmInput,onelswitch,mQrun      
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch       
#include "TLQCDN.h"

      selfZDP=0D0;selfZSP=0D0;selfZ=0D0
      selfZCTDP=0D0;selfZCTSP=0D0;selfZCT=0D0     
c top-gluon part + 1
#define No_OS 
#ifdef No_OS
      SW2=SW**2;CW2=CW**2
      ctfac=   SW2*CW2/16D0/pi**2/vv**2
      fac= ass*SW2*CW2/16D0/pi**3/vv**2
      selfZ=+(2*M12*(-9+2*pi**2+20*LogM12+24*LogM12**2))
     -     /SW**2/CW**2/4D0
       aBfunc(1)=DBLE(B0P(M12,0D0,M12,Q2)   )     
       aBfunc(3)=DBLE(BEpP(M12,0D0,M12,Q2)  ) 
       A0T1=A0T(M12,Q2);   AET1=AEpT(M12,Q2) 
       aB0TN1=B0T(M12, M12, Q2); aBEpTN1=BEpT(M12,M12,Q2)  
       aC0TT3= C0T(M12,M12,M12,Q2)
       aCepTT3= CEpT(M12,M12,M12,Q2)              
       RCMT(1)=ass/3/Pi *(-3*M1 )   
       if(ischeme.eq.1)then
       RCMT(2)=0D0
       else      
       RCMT(2)=-ass/3/Pi *((M1*(a0t1+2*M12*aBfunc(1)))/M12)
       RCMT(3)=-0*ass/3/Pi *((M1*(aet1+2*M12*aBfunc(3)))/M12)         
       endif

       selfZCT=(M1*(36*aBEpTN1*(CW**2+SW2)**2*RCMT(1)-9*CW**4*
     &  ((1+2*aB0TN1+2*aC0TT3*M12-4*aCEpTT3*M12)*RCMT(1)+(2-4*aB0TN1-4*
     &  aC0TT3*M12)*RCMT(2)-4*RCMT(3))+SW**4*(-((17+34*aB0TN1+34*
     &  aC0TT3*M12-4*aCEpTT3*M12)*RCMT(1))+(-34+36*aB0TN1+4*aC0TT3*M12)
     &  *RCMT(2)+36*RCMT(3))+6*CW**2*SW2*((1+2*aB0TN1+2*aC0TT3*M12+28*
     &  aCEpTT3*M12)*RCMT(1)+2*((1+6*aB0TN1+14*aC0TT3*M12)*RCMT(2)+6*
     &  RCMT(3)))))/(3.*CW**2*SW**2)
c       selfZCT= -((ass*M12*(-20+4*LogM12 + 18*LogM12**2 + Pi**2))/(CW2*Pi*SW2))   
       selfZ=-(selfZ*fac + ctfac*selfZCT)  

#else           
       selfZ=(ass*(-31 - 12*LogM12 + 12*LogM12**2)*M12)/(32.*Pi**3*vv**2)
#endif       

#ifdef No_OS
      ctfac=   SW**2/16D0/pi**2/vv**2
      fac=     ass*SW**2/16D0/pi**3/vv**2 
       selfW=+3.*((2*M12)/3. + (4*M12*Pi**2)/9.-(8*M12*LogM12)/3.+ 
     -  16*M12*LogM12**2)/SW**2/4D0
       CF4F3V3=1D0/sqrt2/SW
       selfWCT=-6*CF4F3V3*M1*DCONJG(CF4F3V3)*(RCMT(1)+2*aB0TN1*
     &  RCMT(1)-4*aBEpTN1*RCMT(1)+2*RCMT(2)-4*aB0TN1*RCMT(2)-4*RCMT(3))  
c selfWCT=-(ass*M12*(-13 - 8*LogM12 + 18*LogM12**2 + Pi**2))/(16.*Pi**3*vv**2)  
       selfW=-(selfW*fac + ctfac*selfWCT) 
#else
       selfw=(ass*M12*(-81 - 36*LogM12 + 36*LogM12**2 + 4*Pi**2))/(96.*Pi**3*vv**2)
#endif 
c 
       deltarho2LQCD=(selfz-selfw)
#ifdef printMT4       
       print*, "SMQCD delta rho",(selfz-selfw),-(1 +pi**2/3D0)*ass*M12/(8*Pi**3*vv**2),RCMT(2) ,M1,vv,ass 
#endif         
      end      
